
  needs c api
  needs Byte
  needs Cell
  needs Device
\ ------------------------------------------------------------------------------
\  class CDPlayer              OOP Module for csp4th                  MM-060926
\ ------------------------------------------------------------------------------

  c api definitions

 \ constants from /usr/include/linux/cdrom.h

      $01 constant CDROM_LBA
      $02 constant CDROM_MSF
      $11 constant CDROM_AUDIO_PLAY
      $12 constant CDROM_AUDIO_PAUSED
      $AA constant CDROM_LEADOUT
    $5301 constant CDROMPAUSE
    $5302 constant CDROMRESUME
    $5304 constant CDROMPLAYTRKIND
    $5305 constant CDROMREADTOCHDR
    $5306 constant CDROMREADTOCENTRY
    $5307 constant CDROMSTOP
    $5309 constant CDROMEJECT
    $5312 constant CDROMRESET
    $530B constant CDROMSUBCHNL


    class cdrom_addr
    class cdrom_ti
    class cdrom_tochdr
    class cdrom_tocentry
    class cdrom_subchnl

    cdrom_addr definitions

    Cell this lba

    self seal

    m: mm:ss (O -- a u )
             this lba @ 75 + 0 max 75 / 60 /mod 
             2 (.r) pad place " :" pad +place
             2 '0 (p.r) pad +placez pad count ;

    cdrom_ti definitions

    Byte this trk0
    Byte this ind0
    Byte this trk1
    Byte this ind1

    self seal

    cdrom_tochdr definitions

    Byte this trk0
    Byte this trk1

    self seal

    m: @ (O -- trk0 trk1 )
         this trk0 @  this trk1 @ ;

    m: ? (O -- )
         cr ." first track = " this trk0 ?  
         cr ."  last track = " this trk1 ? ;

    cdrom_tocentry definitions
   
    Byte       this track
    Byte       this adr,ctrl
    Byte       this format   self align
    cdrom_addr this addr
    Byte       this datamode

    self seal

    m: ? (O -- )
         cr ."    track = " this track ?
         cr ." adr,ctrl = " this adr,ctrl ?
         cr ."   format = " this format ?
         cr ." addr lba = " this addr lba ?
         cr ." datamode = " this datamode ? ;

   cdrom_subchnl definitions

    Byte       this format
    Byte       this audiostatus
    Byte       this adr,ctrl
    Byte       this trk
    Byte       this ind   self align
    cdrom_addr this absaddr
    cdrom_addr this reladdr

    self seal

    m: ? (O -- )
         cr ."      format = " this format ?
         cr ." audiostatus = " this audiostatus ?
         cr ."    adr,ctrl = " this adr,ctrl ?
         cr ."         trk = " this trk ?
         cr ."         ind = " this ind ?
         cr ."     absaddr = " this absaddr lba ?
         cr ."     reladdr = " this reladdr lba ? ;


  oop definitions  c api

  class CDPlayer  CDPlayer definitions

    cdrom_ti       this ti
    cdrom_tochdr   this tochdr
    cdrom_subchnl  this subchnl
    cdrom_tocentry this tocentry
    Device         this device

    self seal

    m: ioctl ( args request #args oid -- n ior ) \ MM-090225
             self device fd @ ioctl ;

  \ Open the cdrom device, update the tochdr and the subchnl object and return
  \ the audiostatus and an ior-value on the stack.
  \ on error: ior < 0 and n = invalid
  \ on success : ior = 0 and n = audiostatus
    m: audiostatus (O -- n ior )
         this device r/o/n open ?dup if dup exit then
         this tochdr .. CDROMREADTOCHDR 1 this ioctl dup if exit then 2drop
         CDROM_LBA this subchnl format !
         this subchnl .. CDROMSUBCHNL   1 this ioctl dup if exit then 2drop
         this subchnl audiostatus @ false ;

    m: ? (O -- )
         this audiostatus if ."  io-error: " . exit then drop
         this device ? cr this tochdr ? cr this subchnl ? ;

    m: init (O a u -- )
            this device init this audiostatus 2drop ;

  \ Methods to play a CD

    m: pause (O -- )
             CDROMPAUSE  0 this ioctl nip if exit then cr ." pause " ;

    m: resume (O -- )
              CDROMRESUME 0 this ioctl nip if exit then cr ." resume " ;

    m: stop (O -- )
            CDROMSTOP   0 this ioctl nip if exit then cr ." stop " ;

    m: eject (O -- )
             CDROMEJECT  0 this ioctl nip if exit then cr ." eject " ;

    m: ?trk (O trk# -- trk#' )
            dup 0if drop this tochdr trk1 @ exit then
            dup this tochdr trk1 @ >if drop this tochdr trk0 @ exit then ;

    m: play (O trk# -- )
         this ?trk dup this ti trk0 ! this tochdr trk1 @ this ti trk1 !
         this ti .. CDROMPLAYTRKIND 1 this ioctl nip if drop exit then
         cr ." playing track " . ;

    hide ?trk

    m: play/pause (O -- )
         this audiostatus if drop exit then
         dup CDROM_AUDIO_PAUSED = if drop this resume exit then
             CDROM_AUDIO_PLAY   = if this pause  exit then
         this tochdr trk0 @ this play ;

    m: play.next (O -- )
          this audiostatus if drop exit then
          #21 = if this tochdr trk0 @ 1+ else this subchnl trk @ 1+ then
          this play ;

    m: play.prev (O -- )
          this audiostatus if drop exit then
          #21 = if this tochdr trk1 @ else this subchnl trk @ 1- then
          this play ;


 \ Methods to get audio track information

  \ Read the cdrom tocentry for track trk# and return the oid of the tocentry addr
  \ on the stack. The tocentry addr is the start address of the track. 
  \ Returns the last old tocentry addr on io-error.

    m: addr (O trk# -- oid' )
         CDROM_LBA this tocentry format !  this tocentry track ! 
         this tocentry .. CDROMREADTOCENTRY 1 this ioctl 2drop
         this tocentry addr ;

    m: sot (O trk# -- frames )
         this addr lba @ ;

    m: eot (O trk# -- frames )
         1+ dup this tochdr trk1 @ >if drop CDROM_LEADOUT then this sot ;

    m: time/track (O trk# -- a u )
         dup this eot swap this sot - 300 - this tocentry addr lba !
         this tocentry addr mm:ss ;

    m: done/track (O -- a u )
         this subchnl reladdr mm:ss ;

   oop definitions
\ ----------------------------------------------------------------------------
\ Last revision: MM-090305  +place -> +placez in mm:ss
\                MM-090225  ioctl ( args request #args oid -- n ) -->
\                           ioctl ( args request #args oid -- n ior )
\                           audiostatus (O -- n ) -->
\                           audiostatus (O -- n ior )
\                MM-090212  init adapted to changed Device init method
\                           audiostatus adapted to new Device open method
\                MM-080423  (O

