\  Device.4th
\ -----------------------------------------------------------------------------
\  class Device               OOP Module for csp4th                  MM-060909
\ -----------------------------------------------------------------------------
\
\                     Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
 
  needs Cell
  needs String
  needs c api
 
  c api definitions  decimal

  \ Constants from /usr/include/asm-i386/fcntl.h

     00 constant O_RDONLY
     01 constant O_WRONLY
     02 constant O_RDWR
   4000 constant O_NONBLOCK

  oop definitions  c api
 
  class Device  Device definitions
 
  String this fname \ The full qualified file name of the device.
  Cell   this fd    \ The file descriptor of the device.
 
  self seal

  m: init (O c-addr u -- )
     32 chars this fname init  this fname !  -1 this fd init
   ;

  m: ? (O -- )
     this fname @ dup if ." device=" type space else 2drop then
     ." fd=" this fd ?
   ;

  \ ior values see /usr/include/linux/errno.h

  m: asm ( asm -- ) create , does> @ swap ;

  O_RDONLY               self asm r/o
  O_RDONLY O_NONBLOCK or self asm r/o/n
                  O_RDWR self asm r/w
  O_RDWR O_NONBLOCK or   self asm r/w/n
                O_WRONLY self asm w/o
  O_WRONLY O_NONBLOCK or self asm w/o/n

  hide asm

  m: open (O asm -- ior ) \ ior is 0 or the error code returned from the OS
     this fd @ -1 >if drop false exit then
     this fname @ rot open-file dup if nip else swap this fd ! then ;

  m: close (O -- ior ) \ ior is 0 or the error code returned from the OS
     this fd @ dup -1 =if 1+ exit then
     close-file dup 0if -1 this fd ! then ;

  \ ior values see /usr/include/linux/errno.h
     
  oop definitions
\ -----------------------------------------------------------------------------
\ Last revision: MM-090212 open and close redefined to return the ior on the
\                          stack
\                MM-090124 init ( a u fd -- ) --> init ( a u -- )
\                MM-081006 init changed to set the size of fname to 32 chars
\                MM-080409 stack diagrams
\                MM-080224 path -> fname
\                MM-080216 ioctl moved to the core.
