  needs for,next
  needs String
  needs CDPlayer

  needs GtkFrame
  needs GtkHBox
  needs GtkVBox
  needs GtkLabel
  needs GtkButton
  needs GtkImageButton
  needs GtkTooltips

  needs GTimeout
\ ------------------------------------------------------------------------------
\  class GtkCDPlayer             OOP Module for csp4th                MM-060924
\ ------------------------------------------------------------------------------
\                        Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
  String definitions  \ should be moved later

  m: -trim (O u -- )
           this @ rot - 0 max dup this buffer @ c! + 0 swap c! ;
\ ------------------------------------------------------------------------------

  oop definitions c api also gtk api

  class GtkCDPlayer  GtkCDPlayer definitions  GtkFrame inherit

   GtkVBox        this box
   GtkFrame       this  frame
   GtkLabel       this   [display]
   GtkHBox        this  hbox
   GtkImageButton this   [stop]
   GtkImageButton this   [play]
   GtkImageButton this   [prev]
   GtkImageButton this   [next]
   GtkImageButton this   [eject]

   GtkTooltips this tips
   GTimeout    this timer

   CDPlayer this cdrom
   Cell     this status
   Cell     this trk#
   String   this msg

   Cell     this io-error

   self seal

   :noname (O wid -- )
      this timer remove  this cdrom device close  this tips destroy
    ; 2 20 cb cb.destroy

   :noname (O wid -- )
      this cdrom play.next ; 2 20 cb cb.next

   :noname (O wid -- )
      this cdrom play.prev ; 2 20 cb cb.prev

   :noname (O wid -- )
      this cdrom stop ; 2 20 cb cb.stop

   :noname (O wid -- )
      this cdrom play/pause ; 2 20 cb cb.play

   :noname (O wid -- )
      this cdrom eject ; 2 20 cb cb.eject

  private

   m: trk.msg (O trk# -- )
        dup this trk# ! " <b>Track " this msg !
        dup 2 '0 (p.r) this msg +!  " /" this msg +!  this cdrom tochdr @
        swap - 1+ 2 '0 (p.r) this msg +! " </b>  " this msg +!
        this cdrom time/track   this msg +! "  min  " this msg +! ;

   m: done/track.msg (O a u -- )
        this msg +!  "  min" this msg +! ;

   m: play.msg (O trk# -- )
        this trk# @ over
        <>if \ track number has changed
             this trk.msg
          else
            9 chars this msg -trim
          then
          this cdrom done/track this done/track.msg ;

   m: stop.msg (O -- )
        1 this trk.msg "  0:00" this done/track.msg ;

   m: update.buttons (O status -- )
        dup this status @ = if drop exit then dup this status !
            CDROM_AUDIO_PLAY = 
            if   " gtk-media-pause" " Suspend playing"
            else " gtk-media-play"  " Start / Resume playing"
            then
            this [play] wid this tips !
            this [play] image from-stock button-size ! ;

   m: update.display (O status -- ) 
        dup CDROM_AUDIO_PAUSED = swap CDROM_AUDIO_PLAY = or
        if this cdrom subchnl trk @ this play.msg else this stop.msg then
        this msg @ this [display] text ! ;

   m: ?io-error (O ior -- )
          this io-error @ over this io-error ! over = if drop exit then
          cr ." cdrom io-error: " . ;

   :noname (O -- )
      \ update the display and the buttons
\     this cdrom audiostatus if cr ." cdrom io-error: " dup . then \ MM-090926
      this cdrom audiostatus this ?io-error                        \
      dup 0 <if " <b> No CD </b>" this [display] text ! exit then
      dup this update.buttons this update.display -1
    ; 1 20 cb cb.timer

  public

   m: init (O a2 u2 -- wid )

        this cdrom init  0 this io-error init

        64 chars this msg init   0 this trk# init  0 this status init
     
        " " this init  this shadow-type etched-in   5 this border-width !

        this box init this add   2 this box border-width !

        " " this frame init  this box pack_start_defaults

        2 this frame border-width !  this frame shadow-type in

        this hbox init  0 0 0 this box pack_start

        2 this hbox border-width !

        " <b>GTK+</b>  and  <b>reva-csp Forth</b>" this [display] init

        this frame add

        8 dup this [display] xpad !  this [display] ypad !

        this [display] use-markup yes

        " gtk-media-stop" this [stop] from-stock init  0 0 1 this hbox pack_start
        " gtk-media-play" this [play] from-stock init  0 0 1 this hbox pack_start
        " gtk-media-previous" this [prev] from-stock init  0 0 1 this hbox pack_start
        " gtk-media-next" this [next] from-stock init  0 0 1 this hbox pack_start
        " gtk-cdrom" this [eject] from-stock init 0 0 1 this hbox pack_end

        this [play] is-focus yes

        " clicked" self cb.next  this dup [next] signal connect drop
        " clicked" self cb.prev  this dup [prev] signal connect drop
        " clicked" self cb.stop  this dup [stop] signal connect drop
        " clicked" self cb.play  this dup [play] signal connect drop
        " clicked" self cb.eject this dup [eject] signal connect drop

        1000 this cb.timer this timer init

        " destroy" self cb.destroy this dup signal connect drop

        this tips init

        " Play the next track"      this [next] wid  this tips !
        " Play the previous track"  this [prev] wid  this tips !
        " Stop playing"             this [stop] wid  this tips !
        " Play the current track"   this [play] wid  this tips !
        " Eject the CD"             this [eject] wid this tips !
  ;

  previous oop definitions
\ ------------------------------------------------------------------------------
\ Last revision: MM-090926  io-error  and  ?io-error added
\                MM-090306  :: -> :noname
\                MM-090225  audiostatus (O -- n ) -->
\                           audiostatus (O -- n ior )
\                MM-080803  pack start -> pack_start , pack end -> pack_end
\                           pack defaults start -> pack_start_defaults
\                MM-080706  etched in -> etched-in
\                MM-080423  destroy signal connected from box to this
\                MM-080413  (O
