#! /usr/local/bin/csp4th

   needs GtkToplevel
   needs GtkVBox
   needs GtkMenuBar
   needs GtkSubMenu
   needs GtkMenu
   needs GtkMenuItem
   needs GtkImageMenuItem
   needs GtkAccelGroup

   needs GtkImageFromStock
   needs GtkEventBox
   needs GdkEvent
   needs GdkEventButton

\ ------------------------------------------------------------------------------
\  csp4th OOP                 GtkMenu example.2                       MM-080317
\ ------------------------------------------------------------------------------
\                    Copyright (C) 2008 Manfred Mahlow
\
\                    This code is in the public domain.
\ ------------------------------------------------------------------------------
   
   GtkMenu definitions

   private vocabulary example.2  self example.2 definitions  also gtk api

   GtkToplevel      new window
   GtkVBox          new  vbox
   GtkMenuBar       new   menu-bar
   GtkSubMenu       new     file-menu
   GtkImageMenuItem new       file-open
   GtkMenuItem      new       file-open...
   GtkImageMenuItem new       file-open...(2)
   GtkImageMenuItem new       file-quit
   GtkImageMenuItem new       file-quit(2)
   GtkSubMenu       new     edit-menu
   GtkImageMenuItem new       edit-pref
   GtkSubMenu       new     help-menu
   GtkImageMenuItem new       help-info
   GtkImageMenuItem new       help-about
   GtkEventBox      new   event-box

   GtkAccelGroup    new accel-group


   :noname ( wid data -- ) 2drop gtk main_quit ; 2 20 cb 'destroy

   :noname ( wid data -- ) window destroy accel-group reset ; 2 20 cb 'Ende

   :noname ( wid data -- ) nip cr ." m" . ."  activated " ; 2 20 cb 'activated

   :noname ( oid event -- )
      \? cr ." oid.menu = " over .
      \? dup GdkEvent ?
      dup GdkEvent type GDK_BUTTON_PRESS <>if 2drop false exit then
      \? dup GdkEventButton ?
      GdkEventButton button dup 3 <>if 2drop false exit then
      0 rot GtkSubMenu popup true
    ; 2 30 cb 'clicked
      
   : run ( -- )
         " GtkMenu Example 2" window init   300 300 window default-size !

         vbox init window add

         accel-group init  window accel-group add

         menu-bar init  false false 2 vbox pack_start

         " _Datei" file-menu init  menu-bar append
              " gtk-open" accel-group @ file-open init
              " _Ort öffnen...(1)" file-open... init
              " _Ort öffnen...(2)" 0 file-open...(2) init

              0 if
              " gtk-open"  pad dup off  GtkImage from-stock menu-size init
              file-open...(2) image !
              else
              " gtk-open" GtkImage from-stock menu-size item file-open...(2) image !
              then

              " gtk-quit" 0 file-quit init
              " gtk-quit" accel-group @ file-quit(2) init
              5 0 do file-menu prepend loop

         " _Bearbeiten" edit-menu init  menu-bar append
              " gtk-preferences" accel-group @ edit-pref init  edit-menu append

         " _Hilfe" help-menu init  menu-bar append
              " gtk-help"  accel-group @ help-info  init  help-menu append
              " gtk-about" accel-group @ help-about init  help-menu append

         " activate" 'activated 1 file-open... signal connect drop
         " activate" 'activated 1 file-open signal connect drop
         " activate" 'activated 2 edit-pref signal connect drop
         " activate" 'Ende      0 file-quit signal connect drop
         " activate" 'Ende      0 file-quit(2) signal connect drop

         event-box init  true true 2 vbox pack_end

         " button-press-event" 'clicked file-menu oid 
         event-box signal connect_swapped drop

         " destroy" 'destroy 0 window signal connect drop

         window show_all
    ;


   previous  run term? [IF] ?? [ELSE] gtk main bye [THEN]

\ ------------------------------------------------------------------------------
\ Last revision: MM-090307  DO LOOP ... -> do loop ...
\                MM-090306  :: -> :noname
\                MM-090101  do loop ... -> DO LOOP ... ANS
\                MM-081227  GtkSubMenu popup is now called with two parameters
\                           Direct call to gtk_accel_group_new replaced by new
\                           class GtkAccelGroup
\                MM-080803  gtk quit -> gtk main_quit , show all -> show_all
\                           pack start -> pack_start , pack end -> pack_end









