\  String.4th
\ -----------------------------------------------------------------------------
\  class String             OOP Module for csp4th                     M-060901
\ -----------------------------------------------------------------------------
\
\                    Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
 
  needs Buffer
 
  oop definitions
 
  class String  String definitions
 
  private
 
  Buffer this buffer  \ A buffer for the string.
 
  self seal
 
  m: ?size (S u umax oid -- u|umax )
      drop 2dup > if ." Warning: string overflow" then min
   ;

  m: ?overflow (S u umax -- u|umax )
        2dup > if ." Warning: string overflow" then min
   ;

  public
 
  m: size (S oid -- u )
     self buffer size 2 -
   ;
 
  m: @ (S oid -- c-addr u )
     self buffer @ count
   ;
 
  m: chars (S oid -- u )
     self buffer @ c@
   ;
 
  m: @z (S oid -- c-addr )
     self buffer @ 1+
   ;
 
  m: ! (S c-addr u oid -- )
       (O oid -- ) (S c-addr u -- )
\     this size this ?size this buffer @ placez
      this size self ?overflow this buffer @ placez
   ;
 
  m: !z (S c-addr oid -- )
        (O oid -- ) (S c-addr -- )
     zcount this !
   ;
 
  m: ? (S oid -- )
     self @ type
   ;
 
  m: init (S u oid -- )
          (O oid -- ) (S u -- )
     0 max 255 min 2 + this buffer init pad 0 this !
   ;
 
  m: +! (O c-addr u -- )
\    this size this chars - this ?size  \ overfow ?
     this size this chars - self ?overflow
     this buffer @ +placez
   ;

  oop definitions
\ ----------------------------------------------------------------------------
\  Last revision: MM-090524  this ?size --> self ?overflow
\                 MM-090305  +place -> +placez in +!
\                 MM-090304  place -> placez
\                 MM-090123  bug fixed in ! and +!
\                 MM-080409  stack diagrams
