\ -----------------------------------------------------------------------------
\  class TinyTerm              OOP Module for csp4th                 MM-080211
\ -----------------------------------------------------------------------------
\
\                       Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
  needs oop
  needs ttyS
  needs Cell

  oop definitions decimal  c api  

  class TinyTerm  TinyTerm definitions  ttyS inherit

  Cell this rx-handler
  Cell this tx-handler
  Cell this exit-handler

  private

  m: tx.0 (O b -- ) \ default tx-handler
     this tx drop ;

  m: rx.0 (O b -- ) \ default rx-handler
     emit ;

   m: io-handler (O -- )
      begin
        key? if
          stdin rx if drop else
            dup 27 = if drop stdin flush drop exit then
            this dup tx-handler @ execute
          then
        then
        this rx if drop else this dup rx-handler @ execute then
     again ;

   public

   m: init (O cflags iflags oflags lflags a u rx-handler tx-handler -- )
      ?dup 0if self ['] tx.0 then this tx-handler init
      ?dup 0if self ['] rx.0 then this rx-handler init
      0 this exit-handler init
      this init ;

   m: close (O -- )
        this dup exit-handler @ dup if execute else 2drop then
        this close drop ;

   m: open (O -- )
      this r/w/n open if this fname ? ." : open error " . -1 throw then
      cr ." Terminal: " this ?
      cr cr
         ."           Press [Esc] to return to the Forth Interpreter."
      cr cr 
      stdin fd @ >r
      r@ stdin old-termios read drop
      r@ stdin new-termios read drop
      stdin new-termios lflags @ ECHO ICANON or not and
      stdin new-termios lflags !
      r@ stdin new-termios write drop
      this io-handler  \ stay in the io-handler until <esc> key is pressed
      r> stdin old-termios write drop this close ;

  oop definitions
\ -----------------------------------------------------------------------------
\  Last revision: MM-090301  exit-handler added
\                 MM-090215  updated because io-words now return ior values
\                 MM-080531  Reva repeat while -> begin 0until
\                 MM-080409  stack diagrams
