\  c/api/termios.4th
\ -----------------------------------------------------------------------------
\  iface termios              OOP Module for csp4th                  MM-070303
\ -----------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
  needs c api
  needs Byte

  c api definitions  decimal
 
  $5401 constant TCGETS    \ from /usr/include/asm-i386/ioctls.h 
  $5402 constant TCSETS
 
 \ C_CFLAG bits :
 
         4111 constant CBAUD   \ baud rate constants
            0 constant B0
            7 constant B300
            9 constant B1200
           11 constant B2400
           12 constant B4800
           13 constant B9600
           14 constant B19200
           15 constant B38400
         4097 constant B57600
         4098 constant B115200
 
           48 constant CSIZE   \ character size constants
            0 constant CS5
           16 constant CS6
           32 constant CS7
           48 constant CS8
 
          768 constant CPARITY  \ parity constants
            0 constant PARNONE
          256 constant PAREVEN
          768 constant PARODD
 
           64 constant CSTOPB   \ stop bits constants
            0 constant ONESTOPB
           64 constant TWOSTOPB
         2048 constant CLOCAL
          128 constant CREAD   
  -2147483648 constant CRTSCTS
 
 \ C_IFLAG bits :
 
 \          1 constant IGNBRK
 \          2 constant BRKINT
 \          4 constant IGNPAR
 \          8 constant PARMRK
 \         16 constant INPCK
 \         32 constant ISTRIP
 \         64 constant INLCR
 \        128 constant IGNCR
          256 constant ICRNL
 \        512 constant IUCLC
         1024 constant IXON
         2048 constant IXANY
         4096 constant IXOFF
 \       8192 constant IMAXBEL
 
 \ C_OFLAG bits :
 
            1 constant OPOST
 \          2 constant OLCUC
            4 constant ONLCR
 \          8 constant OCRNL
 \         16 constant ONOCR
 \         32 constant ONLRET
 \         64 constant OFILL
 \        128 constant OFDEL
 \        256 constant NLDLY
 
 \ C_LFLAG bits :
 
 \          1 constant ISIG
            2 constant ICANON
 \          4 constant XCASE
            8 constant ECHO
 \         16 constant ECHOE
 \         32 constant ECHOK
 \         64 constant ECHONL
 \        128 constant NOFLSH
 \        256 constant TOSTOP
 \        512 constant ECHOCTL
 \       1024 constant ECHOPRT
 \       2048 constant ECHOKE
 \       4096 constant FLUSHO
 \      16384 constant PENDIN
 \      32768 constant IEXTEN

  19 constant NCCS


  class C_FLAGS  C_FLAGS definitions  4 self allot  self seal

   m' @ alias @

   m' ! alias !


  c api definitions

  class C_IFLAG  C_IFLAG definitions  C_FLAGS inherit  self seal

   m: ? (S oid -- ) self @ ICRNL and if ." ICRNL " then ;

  c api definitions

  class C_OFLAG  C_OFLAG definitions  C_FLAGS inherit  self seal

   m: ? (S oid -- ) self @ ONLCR and if ." ONLCR " then ;

  c api definitions


  class C_CFLAG  C_CFLAG definitions  C_FLAGS inherit  self seal

   m: ?B (S oid -- )
      'B emit self @ CBAUD and
      dup   B1200 = if ." 1200 "   drop exit then
      dup   B2400 = if ." 2400 "   drop exit then
      dup   B4800 = if ." 4800 "   drop exit then
      dup   B9600 = if ." 9600 "   drop exit then
      dup  B19200 = if ." 19200 "  drop exit then
      dup  B38400 = if ." 38400 "  drop exit then
      dup  B57600 = if ." 57600 "  drop exit then
      dup B115200 = if ." 115200 " drop exit then
      ." __?__ " drop
    ;

   m: ?D (S oid -- )
      self @ CSIZE and
      dup CS7 = if ." 7" drop exit then
      dup CS8 = if ." 8" drop exit then
      ." ?" drop
    ;
 
  m: ?P (S oid -- )
     self @ CPARITY and
     dup PARNONE = if ." N" drop exit then
     dup PAREVEN = if ." E" drop exit then
     dup PARODD  = if ." O" drop exit then
     ." ?" drop
   ;
 
  m: ?S (S oid -- )
     self @ CSTOPB and
     dup ONESTOPB = if ." 1 " drop exit then
     dup TWOSTOPB = if ." 2 " drop exit then
     ." ?" drop
   ;
 
  m: ?H (S oid -- )
     self @ CRTSCTS and if ." CTS/RTS " then
   ;
 
  m: ?L (S oid -- )
     self @ CLOCAL and if ." CLOCAL " then
   ;

  m: ? (O -- )
       this ?B this ?D this ?P this ?S this ?H this ?L ;

   c api definitions


  class C_LFLAG  C_LFLAG definitions  C_FLAGS inherit  self seal

   c api definitions


  class C_LFLAG  C_LFLAG definitions  C_FLAGS inherit  self seal

   c api definitions


  class C_LINE  C_LINE definitions  1 self allot  self seal

   m' c@ alias @
   m' c! alias !

  c api definitions


  class C_CC  C_CC definitions  NCCS self allot  self seal

   here \ defaults for a ttyS device
          $03 c, \ VINTR
          $1C c, \ VQUIT
          $7F c, \ VERASE
          $15 c, \ VKILL
          $04 c, \ VEOF
          $00 c, \ VTIME
          $01 c, \ VMIN
          $00 c, \ VSWTC
          $11 c, \ VSTART
          $13 c, \ VSTOP
          $1A c, \ VSUSP
          $00 c, \ VEOL
          $12 c, \ VREPRINT
          $0F c, \ VDISCARD
          $17 c, \ VWERASE
          $16 c, \ VLNEXT
          $00 c, \ VEOL2
          $00 c,
          $00 c,

   m: init (S oid -- ) literal swap self units move ;

   m: vtime (S oid1 -- oid2 ) 5 + Byte ;

   m: vmin (S oid1 -- oid2 ) 6 + Byte ;

   c api definitions

  class termios  termios definitions

   C_IFLAG this iflags   \ input mode flags
   C_OFLAG this oflags   \ output mode flags
   C_CFLAG this cflags   \ control mode flags
   C_LFLAG this lflags   \ local mode flags
   C_LINE  this line     \ line discipline
   C_CC    this cc       \ control characters

   self seal

   m: read (S fd oid -- ior )
        TCGETS rot 1 swap ioctl nip
        \? dup if ."   termios read error " . cr then
    ;

   m: write (S fd oid -- ior )
        TCSETS rot 1 swap ioctl nip
        \? dup if ."   termios write error " . cr then
    ;

  oop definitions
\ -----------------------------------------------------------------------------
\ Last revision: MM-090213  @ (S fd oid -- ) --> read (S fd oid -- ior )
\                           ! (S fd oid -- ) --> write (S fd oid -- ior )
\                MM-080409  stack diagrams
