\  help.4th
\ -----------------------------------------------------------------------------
\  help utility for csp4th                                           MM-080205
\ -----------------------------------------------------------------------------
\
\                   Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
\ This module must be loaded as the first one.

\ needs os console-test

  needs ANSI-ESC-Sequences

  loc:

  variable h.fd   h.fd off

  variable h.fp  h.fp off

  : h.item ( -- a ) scratch ;
  : h.scontext ( -- a ) h.item 255 + ;
  : h.buf ( -- ) h.scontext 255 + ;

  create a,u 2 cells allot   h.buf 1+ 0 a,u 2!

  s.context @ constant core-wordlist  

  : ((cn) ( cid -- a u )
  \ Return the name of the context 'cid'
    cell+ @ $FFFFFFFC and >name count ;   \ clear flags

  : (cn) ( cid -- a u )
  \ Return the name of the context cid. Return "forth" for the core-wordlist.
    dup core-wordlist =if drop "  forth" exit then
    0; dup %1 and 0if . exit then  \ print wordlist id and exit
       " " rot
       0 swap begin >r 1+ r@ #3 cells + @ dup 0until drop
              begin -rot r> ((cn) bl join rot 1- dup 0until drop ;

  : h.fname ( a1 u1 -- a2 u2 )
            " hlp" '. join  " help" 2swap 0 join bl2ps ;

0 [IF]
  : h? ( -- )
       cr ." help context : " h.scontext count '| emit type '| emit
       cr ." help file    : " h.scontext count h.fname type  ."   fd = " h.fd @ .
       cr ." help item    : " h.item count '| emit type '| emit
       cr ." help buffer  : " h.buf count swap . .
       cr ." a,u          : " a,u 2@ swap . .
       cr ." h.fp         : " h.fp @ .
   ;
[THEN]

0 [IF]
  : h.open ( -- )
           h.scontext count h.fname 2dup /?/ open/r 
           dup 0 >if h.fd ! 2drop  h.fp off   0 h.buf c!  h.buf count a,u 2!
                  else drop cr ." Sorry, no help for" 
                       h.item count '\ skip 
                       dup 0if 2drop h.scontext count then type ."     "
                       type ."   Caught: -37" cr -37 throw
                  then ;
[ELSE]
  : h.open ( -- )
           h.scontext count h.fname 2dup /?/ r/o open-file 
           0if h.fd ! 2drop  h.fp off   0 h.buf c!  h.buf count a,u 2!
                  else drop cr ." Sorry, no help for" 
                       h.item count '\ skip 
                       dup 0if 2drop h.scontext count then type ."     "
                       type ."   Caught: -38" cr -38 throw
                  then ;
[THEN]


   : h.close ( -- ) h.fd @ close-file drop h.fd off ;

0 [IF]
   : h.@buf ( -- u ) \ cr ."  @buf : " .s
            h.fp @ h.fd @ seek h.buf 1+ 255 h.fd @ read
            dup h.buf c!  h.buf count a,u 2! ;
[ELSE]
   : h.@buf ( -- u ) \ cr ."  @buf : " .s

          | h.fp @ h.fd @ seek h.buf 1+ 255 h.fd @ read-file drop  | MM-090920
            h.fp @ 0 h.fd @ reposition-file drop
            h.buf 1+ 255 h.fd @ read-file drop
            dup h.buf c!  h.buf count a,u 2! ;

[THEN]



   : h.@line ( -- a3 u3 -1 | 0 )
             begin
               \ cr  ." h.@line : " h.fp @ .
               a,u 2@ ( a1 u1 ) 10 split if
                  ( a2 u2 a1 u1' ) 2swap a,u 2! dup 1+ h.fp +! -1 exit
               else ( a1 u1 )
                 2drop h.@buf
               then
             0until 0 ;

   : h.text ( -- )
       begin
         h.@line 0if exit then
         dup if cr type -1 else 2drop 0 then
       0until ;

false [IF]
   : h.head ( -- -1|0 )
       begin
         h.@line 0if 0 exit then
         over h.item c@  h.item count 
         cmp 0if
           cr ." Glossary: "  h.item count bold type normal
           h.scontext count "  Glossary" cmp
           if ."  in the context " h.scontext count bold type then
           cr cr type normal  -1 exit
         then
         2drop
      again ;
[ELSE]
   : h.head ( -- -1|0 )
       begin
         h.@line 0if 0 exit then
         over h.item c@  h.item count 
         cmp 0if
           cr ." Glossary: "  h.item count bold type normal
           dup h.item c@ >if
             ."  in the context " h.scontext count bold type cr cr type
           else
             2drop
           then
           normal -1 exit       
         then
         2drop
      again ;
[THEN]


   : (h) ( -- f ) \ f=true if a glossary entry was displayed.
       h.open
       h.item c@
       0if
         h.text cr true
       else
         h.head  if
           h.text cr  true
         else
        \  cr  h.item count bl skip type ." ? not found  "
        \   cr  h.item count bl skip type ." ? no glossary entry  "
           false
         then
       then
       h.close
    ;

   variable x  x off
0 [IF]
   : (o) ( -- ) \ lookup h.item in all contexts of the current search order
         x off get-order 0 DO
           x @ 0if (cn) h.scontext place (h) x ! else drop then 
         LOOP
         x @ 0if
           "  Glossary" h.scontext place (h)
          0if cr  h.item count bl skip type ." ? no glossary entry  " then

         then ;
[THEN]

   : (o) ( -- ) \ lookup h.item in all contexts of the current search order
         context dup @ begin dup while
                         (cn) h.scontext place (h)
                         0if cell+ dup @ else drop false dup then
                       repeat drop
         if
           "  Glossary" h.scontext place (h)
           0if cr  h.item count bl skip type ." ? not found  " then
         then ;


   :noname ( "name" -- )
      parsews dup 0if \ name=""
        2drop " " h.item place context @ (cn) h.scontext place (h) drop
      else
        "  " h.item place  2dup h.item +place  bl h.item c+place 
        find if
          s.context @ (cn) h.scontext place (h) \ 0if -13 throw then
          0if cr  h.item count bl skip type ." ? no glossary entry  " then
        else
          2drop ( "  Glossary") (o)
        then
      then
    ;
\     h.scontext place (h) drop  ;

   loc;

   : h ( "name" -- ) literal catch drop ;

\ -----------------------------------------------------------------------------
\  Last revision: MM-090925 console -> ANSI-ESC-Sequences
\                 MM-090920 seek -> reposition-file
\                 MM-090306 :: -> :noname
\                 MM-090125 close , open/r , read  replaced with  close-file ,
\                           open-file , read-file
\                 MM-080823 ." ? not found  " -> ." ? no glossary entry found  "
\                 MM-080530 Reva repeat while -> begin 0until
\                 MM-080226 No "\ " prefix for headers any more.

