
  needs libs
  needs c api
\ ------------------------------------------------------------------------------
\  IEEE Floating Point Numbers      OOP Module for csp4th             MM-070314
\ ------------------------------------------------------------------------------
\                      Copyright (C) 2008 Manfred Mahlow
\
\  This is Open Source Software released under the "Artistic License". See the
\  enclosed LICENSE file.
\ ------------------------------------------------------------------------------
\
\  This is a quick preliminary hack to add floating point input and output to
\  csp4th. The background is, that the library interface does not return floats
\  and doubles properly.

  oop definitions

  lib new libfloats

  " ieee/libfloats.so.0.0" /?/ libfloats init

  c api definitions

\  libfloats import __str2sf ( sp -- 0|c )   \ ( a sp -- sf 0|c )
\  libfloats import __ascii2sf ( sp -- 0|c ) \ ( a sp -- sf 0|c )

  libfloats import __str2df ( sp -- 0|c )   \ ( a a sp -- df 0|c )
  libfloats import __ascii2df ( sp -- 0|c ) \ ( a a sp -- df 0|c )

  libc import sprintf ( *s *f n d d -- n|-n )

  libfloats import __df2sf ( dl dh -- sf )

  libfloats import __sf2df ( sp sf -- dh )     \ ( sf sp sf -- df )

  libfloats import __s2df ( sp -- )         \ ( sf sf sp -- df )

  libfloats import __df2s ( dl dh -- n )   \ ( df -- n )   




 forth definitions  oop c api

\ string to 64 bit IEEE floating point number conversion

 : >df ( a u -- df true | false )
 \ Convert string a,u to a double floating point number df ( 64 bit IEEE ).
   zt dup sp@ __str2df ( -- ? ? c | dl dh 0 ) if 2drop 0 else -1 then ;

 : ascii>df ( a u -- df true | false )
 \ Convert ascii string a,u to a 64 bit floating point number df.
   zt dup sp@ __ascii2df ( -- ? ? c | dl dh 0 ) if 2drop 0 else -1 then ;

\ 64 bit IEEE floating point number input

 :noname ( a u -- a u 0 | lf 3 )
  \ Try to convert the ascii string a,u to a double floating point number.
  \ Return the number and a '3' on the TOS or return the string a,u and false.
    2dup ascii>df 0if [ ' word? defer@ ] compile, exit then 2swap 2drop 3
  ; is word?

\ 64 bit IEEE floating point number to string conversion

 : df> ( df u1 -- pad u2 )
 \ Convert double floating point number d to a string at pad with u decimals.
  >r >r >r pad " %1.*f " drop r> r> r> -rot sprintf pad swap ;

\ 64 bit IEEE floating point number printing

 : df.n ( df u -- )
 \ Print double floating point number d with u decimals.
   df> dup 0 <if ." number conversion error " -1 throw then type ;

 : df. ( df -- )
 \ Print the double floating point number d with 2 decimals.
   2 df.n ;

\ mixed number conversion

  : sf>df ( sf -- df )
  \ Convert 32 bit to 64 bit IEEE floating point number.
    sp@ over __sf2df ;


  : df>sf ( df -- sf )
  \ Convert 64 bit to 32 bit IEEE floating point number.
   __df2sf ;

  : s>df ( n -- df )
  \ Convert single to 64 bit IEEE floating point number.
    dup sp@ __s2df ;

  : df>s ( df -- n )
  \ Convert 64 bit IEEE floating point number df to a single cell signed
  \ integer, that is the integer portion of df. Discard the fractional 
  \ portion of df.
    __df2s ;

  [DEFINED] gtk [IF] gtk api [DEFINED] GObject [ELSE] false [THEN]

    [IF] GObject [DEFINED] gdouble [ELSE] false [THEN]

      [IF]  GObject gdouble definitions

            m: ? ( oid a.prop_name u.prop_name -- ) self @ 3 df.n ;

      [THEN]

   oop definitions
\ ------------------------------------------------------------------------------
\ Last revision: MM-090306  :: -> :noname
