\  tty.4th
\ -----------------------------------------------------------------------------
\  class tty               OOP Module for csp4th                     MM-080211
\ -----------------------------------------------------------------------------
\
\                    Copyright (C) 2008 Manfred Mahlow
\
\ This is Open Source Software released under the "Artistic License". See the
\ enclosed LICENSE file.
\ -----------------------------------------------------------------------------
  needs c api termios
  needs Device
  needs Cell
 
  c api definitions  decimal
 
  $540B constant TCFLSH    \ from /usr/include/asm-i386/ioctls.h 
 
  oop definitions  c api
 
  class tty  tty definitions  Device inherit

   termios this new-termios  \ buffer to manipulate the device termios
   termios this old-termios  \ buffer to save and restore the device termios

  self seal

  m: write (O a u -- ior )
     this fd @ write-file
   ;

  m: tx (O c -- ior )
     sp@ 1 this write nip
   ;

  m: flush (O -- ior )
     2 TCFLSH 1 this fd @ ioctl nip
   ;

  m: read (O a u1 -- u2 ior ) \ MM-090213  ior = -11 = try again
     this fd @ read-file dup -11 = if 11 + then 
   ;

  m: rx (O -- c ior )
     0 sp@ 1 this fd @ read-file nip
   ;

  m: ? (O -- )
     this ?
     this fd @ dup 0 < if drop exit then
     pad termios read if ." termios read error " exit then
     pad termios cflags ?
     pad termios iflags ?
     pad termios oflags ?
   ;

  forth definitions

  stdin  tty new stdin  " " stdin init  stdin fd !
  stdout tty new stdout " " stdout init stdout fd !

  \? ."   'stdin' and 'stdout' are tty objects now. "
 
  oop definitions
\ -----------------------------------------------------------------------------
\  Last revision: MM-090213  read write rx tx flush rewritten to return an ior
\                            on the stack
\                            termios --> new-termios , \termios --> old-termios
\                 MM-090124  ? changed not to display "device=" if no fname
\                              was set
\                            adapted to the changed Devide init method
\                 MM-090105  path -> fname
\                 MM-080409  stack diagrams

\  Note: You can use the command  stty -F /dev/ttySx -a   in a terminal to
\        display the parameters of /dev/ttySx.





