; Linux core:
; MM-090809 : io_close io_read io_size io_write removed
; MM-090808 : io_create removed
; MM-090305 : _pplace -> _pplacez
; MM-090207 : file_size added, should replace io_size
;             file_pos and repos_file added
; MM-090204 : sys_creat added
; MM-090131 : sys_read deleted , sys_write -> write_file
;             openrw deleted
; MM-090127 : read-file added
; MM-090125 : sys_close , sys_open , sys_read , sys-write added
; MM-090123 : allocate_ans added to replace old allocate
; MM-080815 : revacore.asm -> csp4th-core.asm
; MM-080101 : _move renamed to _cmove

OS = 1
include 'macros'

format elf
section '.flat' writeable executable
public _start
extrn dlopen
extrn dlclose
extrn dlsym
extrn malloc
extrn free
extrn realloc

struc termios {
	.iflag rd 1
	.oflag rd 1
	.cflag rd 1
	.lflag rd 1
	.line rb 1
		rd 1 ; pad
	.cc rb 32
	.ispeed rd 1 
	.ospeed rd 1
		rd 1
}
struc stat_t {
	.dev	rd 2 	; + 0
		rd 1 	; + 8; pad
	.inode	rd 1	; +12
	.mode	rd 1	; +16
	.nlink	rd 1	; +20
	.uid	rd 1	; +24
	.gid	rd 1	; +28
	.rdev	rd 2	; +32
		rd 1	; +40 pad
	.size	rd 1	; +44
	.hsize	rd 1	; +48
	.blksize rd 1	; +52
	.blocks	rd 1	; +56
	.atime	rd 1	; +60
	.mtime	rd 1	; +64
	.ctime	rd 1	; +68
		rd 6	; -- +100
}

linux_read = 3
linux_write = 4
linux_open = 5
linux_close = 6
linux_creat = 8
linux_unlink=10
linux_seek64=140
linux_fstat64=197
linux_ftruncate=194 ; ftruncate64
linux_rename=38
linux_stat=106
linux_fsync=118
linux_signal=48
linux_sigaction=67
linux_sigsuspend=72
linux_sigpending=73
linux_sigreturn=119
linux_getpid=20
linux_readlink=85
linux_select=82
SEEK_SET=0
SEEK_CUR=1
SEEK_END=2
SIG_ERR=-1
SIG_DFL=0
SIG_IGN=1

SIGHUP=1
SIGINT=2
SIGQUIT=3
SIGILL=4
SIGTRAP=5
SIGABRT=6
SIGBUS=7
SIGFPE=8
SIGKILL=9
SIGUSR1=10
SIGSEGV=11
SIGUSR2=12
SIGPIPE=13
SIGALRM=14
SIGTERM=15
O_RDONLY	    = 0
O_WRONLY	    = 1
O_RDWR		    = 2

; These macros must be defined prior to the general code:
macro BSS { section ".bss"
stat_buf stat_t
in_termios   rd 17 ; termios
out_termios  rd 17 ; termios
ourpid rd 1
fd_set  rd 1	; for select call in 'iskey'
tv	rd 2	; also
bss_start:
}
macro NONBSS {
procname db '/proc' ; actually includes the / from 'exe', so don't separate them!
exe db '/exe'
align 4
rb 16
}


; OS-specific code is here: ---------------------------------------------
PROC os_start
	mov dword [StdOut], 1
	mov dword [StdIn], 0
	; save argc, argv
	mov eax, [esp+4]
	mov [argc], eax
	mov eax, [esp+8]
	mov [argv], eax
	mov eax, [argc]
	mov eax, [esp+4*eax+12]
	mov [environ], eax
	; Now, let's get the pid
	mov eax, linux_getpid
	int 80h
	mov [ourpid], eax

	; get our file path.
	; first construct the file name.
	upsh procname
	upsh 6
	upsh __pad
	call _place
	; convert pid to decimal value
	upsh [ourpid]
	upsh 0
	call _printr	; stack contains the string nnnn corresponding to our pid
	upsh __pad
	call _pplace	; append
	upsh exe
	upsh 4 
	upsh __pad
;	call _pplace	; append
        call _pplacez   ; MM-090305
	; 'pad' has the proc name corresponding to our EXE.  Let's figure out what it is:
	upsh __pad
	mov ebx, __pad
	inc ebx
	mov edx, 255
	mov ecx, app_file_name
	mov eax, linux_readlink
	int 80h
	cmp eax, -1
	jne .readlinkok
	; failed reading the link, probably we don't have permission.  Assume
	; 'argv[0]' has the correct value (woe to us if it doesn't!)
	upsh [argv]
	call _zcount
	inc eax	; include NUL
	upsh app_file_name
	swap
	call _cmove
.readlinkok:

	; set signal handlers

       ; The args go in ebx, ecx, edx, esi, edi, ebp, in that order.
       ; (this is from the Linux Assembly HOWTO)
;        mov ebx, SIGSEGV	; illegal access
;	mov ecx, segv
;	mov eax, linux_signal
;	int 80h
;
;        mov ebx, SIGINT	; ctrl+c
;	mov ecx, segv
;	mov eax, linux_signal
;	int 80h
;	drop
;	ret

;segv:
;	lea eax, [esp+4]
;	mov eax, [eax]
;	mov dword [except_code], eax 
;	mov [except_addr], eax
;	call reset
;	call exception
;	jmp  hello

	;save terminal state
;	call term_save

	mov esi, [tempX]
	; save argc, argv
	ret
ENDP os_start

os_type:
        upop edx                ;
        mov ecx, eax
        or edx,edx              ; Is the count zero?
        jz .done                ; If so, we can exit
        mov ebx, 1              ; stdout
        mov eax, 4              ; sys_write
        int 80h                 ; Linux syscall
.done:
        drop
	ret

os_emit:
	mov ebx, 1	;stdout
	mov edx, ebx	;count
	lea ecx, [esp-4]
	mov [ecx], eax
	mov eax, 4	;sys_write
	int 80h
.done:
	drop
	ret

align 4
os_key:
	dup
	sub ebx,ebx	;0 = stdin
	mov edx, 1	;count
	push ebx
	mov ecx, esp
	mov eax, 3
	int 80h
	pop eax
	ret
;os_ekey:
;	dup
;	push esi
;	call non_canonical_input
;	call os_key
;	push eax
;	call term_restore
;	pop eax
;	pop esi
;	ret

TCGETS = 5401h
TCSETS = 5402h
TCSETSW = 5403h
TCSETSF = 5404h

ISIG=1
ICANON=2
XCASE=4
ECHO=10o
ECHOE=20o
ECHOK=40o
ECHONL=100o
NOFLSH=200o
TOSTOP=400o
ECHOCTL=1000o
ECHOPRT=2000o
ECHOKE=4000o
FLUSHNO=10000o
PENDIN=40000o
IEXTEN=100000o

; get terminal state into 'in_termios'
; and also 'out_termios' -- this is the one we play with
;term_save:
;	mov eax, 54
;	xor ebx, ebx
;	mov ecx, TCGETS
;	mov edx, out_termios
;	int 80h

;	mov ecx, TCGETS
;	mov edx, in_termios
;term_do:
;	mov eax, 54
;	xor ebx, ebx
;	int 80h
;	ret
; restore terminal to original state:
;term_restore:
;	mov ecx, TCSETSW
;	mov edx, in_termios
;	jmp term_do

;non_canonical_input:
;	mov edx, out_termios
;	mov dword [edx+12], ECHONL
;	mov ecx, TCSETSW
;	jmp term_do
;;---------------------------------------------------------------------
PROC os_bye
	mov ebx, eax
	mov eax, 1	;1 = sys_exit
	int 80h
ENDP os_bye
align 4

PROC os_syscall
       ; syscalls can take a variable number of arguments, from 0 to 6.
       ; The args go in ebx, ecx, edx, esi, edi, ebp, in that order.
       ; (this is from the Linux Assembly HOWTO)

       ; At entry, the Forth stack holds args, argcount, syscall-number

       ; validate argcount, if > 6 return without changing the stack
       	cmp dword [esi], 6
           jbe lsc_ok
           ret
lsc_ok:                             ; do a swap on the data stack
           push eax
           mov eax, [esi]
           pop dword [esi]         ; swapped eax=argcount

           mov [lsc_rsp], esp      ; save current return stack
           mov esp, esi            ; now point return stack to data stack
           dec eax                 ; adjust and set s flag
           js  lsc_0               ;   if 0 jump to first index
           mov eax, [lsc_tbl+eax*4]    ; index into jump table
           jmp eax

           ; entered the pop statements individually for clarity.

lsc_0:      pop eax
           jmp lsc_m
lsc_1:      pop eax
           pop ebx
           jmp lsc_m
lsc_2:      pop eax
           pop ebx
           pop ecx
           jmp lsc_m
lsc_3:      pop eax
           pop ebx
           pop ecx
           pop edx
           jmp lsc_m
lsc_4:      pop eax
           pop ebx
           pop ecx
           pop edx
           pop esi
           jmp lsc_m
lsc_5:      pop eax
           pop ebx
           pop ecx
           pop edx
           pop esi
           pop edi
           jmp lsc_m
lsc_6:      pop eax
           pop ebx
           pop ecx
           pop edx
           pop esi
           pop edi
           pop ebp
           ;  fall through
lsc_m:      int 80h
           mov esi, esp            ; restore adjusted data stack
           mov esp, [lsc_rsp]      ; restore the return stack
	   ret
ENDP os_syscall

lsc_rsp:    dd 0
lsc_tbl:    dd lsc_1
           dd lsc_2
           dd lsc_3
           dd lsc_4
           dd lsc_5
           dd lsc_6


; syscall interface ends here
;---------------------------------------------------------------------
; ANS FILE ACCESS WORDS
;---------------------------------------------------------------------
os_ro = O_RDONLY
os_rw =	O_RDWR
os_wo = O_WRONLY

; EAX is system call to make
; parms are EBX, ECX, EDX, ESI, EDI
; retval in EAX, negative on failure

; ior is 0 if succeeded.
macro linux { int $80 }

PROC openr ; ( a n -- fileid )
	mov ecx, O_RDONLY
	; fall through
	
; sys_open(filename, flags, mode) --> handle
; ( c-addr u fam -- fileid ior ) \   s" file.txt" r/o open-file
;	upop ecx	; flags O_RDONLY etc.
io_open:
	call _zt
	mov ebx, eax	; filename
	xor edx, edx	; mode
	mov eax, linux_open
call_linux:
	linux
call_linux_return: ; convert value in EAX into 'ior'
	mov ebx, eax	
call_linux_return2: ; convert value in EBX into 'ior'
	; ebx<0 --> 1 else 0
	test ebx, ebx
	js .end
	xor ebx, ebx
	jmp .end
.end:	mov [__ior], ebx
	test ebx, ebx	; jnz is error
	ret
ENDP openr

; sys-creat ( c-addr fam -- ior ) MM-090204
;           c-addr is the address of a zero-terminated string
;           ior >= 0 : fid , ior < 0 = error code 
; Creates a new file with mode rw-,r--,r--/--- = 644o . If file with the name
; c-addr already exists, truncate its length to zero without warning.
PROC sys_creat
        upop ecx	; flags to ecx
	or ecx, 1100o
	mov ebx, eax	; filename
	mov edx, 644o
	mov eax, linux_open
	linux
	ret
ENDP sys_creat

; sys-open ( c-addr fam -- ior ) MM-090125
;             c-addr is the address of a zero-terminated string
;             ior >= 0 : fid , ior < 0 = error code 
PROC sys_open
        upop ecx	; flags to ecx
	mov ebx, eax	; filename
	xor edx, edx	; mode
	mov eax, linux_open
	linux
	ret
ENDP sys_open

; close-file ( fd -- ior ) MM-090131
; ( fid -- ior ) MM-090125
PROC close_file
	mov ebx, eax
	mov eax, linux_close
        linux
        ret
ENDP close_file

; read-file ( a u fd -- u2 ior ) MM-090127  u2 = 0 on error
PROC read_file
	mov ebx, eax	; fileid
	drop
	mov edx,eax	; count
	drop
	mov ecx	,eax	; addr
	mov eax, linux_read
	linux
        xor edx, edx
        test eax, eax
        jns .end
   	mov edx, eax
        xor eax, eax
.end:   upsh edx
        ret            
ENDP read_file

; write-file ( c-addr u fd -- ior ) MM-090131
PROC write_file
	mov ebx, eax	; fileid
	drop
	mov edx,eax	; count
	drop
	mov ecx	,eax	; c-addr
	mov eax, linux_write
	linux
        test eax, eax
        js .end
        xor eax, eax
.end:   ret
ENDP write_file

; ( c-addr u -- x ior )
;PROC io_status
;	call _zt
;	push eax 
;	drop
;	pop ebx
;	mov ecx, stat_buf
;	mov eax, linux_stat
;	call call_linux
;	upsh dword [stat_buf.mode]	; third element is ior
;	swap
;	ret
;ENDP io_status

; file_size ( fd -- ud ior) MM-090207
PROC file_size
	mov ebx, eax
	mov ecx, stat_buf
	mov eax, linux_fstat64
	linux
	mov ebx, eax
        mov eax, dword [stat_buf.size]
        dup
	mov eax, dword [stat_buf.hsize]
        upsh ebx
	ret
ENDP file_size

; file-position ( fd -- ud ior ) MM-090207
PROC file_pos
	mov ebx, eax ; fd
        xor ecx, ecx
        xor edx, edx
        sub esi, 8   ; *result
        push esi
        mov edi, SEEK_CUR
	mov eax, linux_seek64
        linux
        pop esi
        mov ebx, [esi]
        xchg ebx, [esi+4]
        mov [esi], ebx
        ret
ENDP  file_pos


; reposition-file ( ud fd -- ior )  MM-090207
PROC repos_file
	upop ebx ; fd
	upop ecx ; ud.h
	upop edx ; ud.l
        dup
	push esi
        sub esi, 8 ; *result
	mov edi, SEEK_SET
        mov eax, linux_seek64
	linux
        pop esi
	ret
ENDP repos_file



;---------------------------------------------------------------------
; ANS MEMORY ALLOCATION WORDS
;---------------------------------------------------------------------

; libc routines used
; ( u -- a ior )  MM-090114
PROC mem_alloc_ans
	push eax	
	call malloc
	add esp, 4
.0:     cmp eax, 0
        upsh -1
        jz .1
        inc eax
.1:	ret
ENDP mem_alloc_ans

; ( a -- ior ) MM-090114
PROC mem_free_ans
	push eax
	call free
	add esp, 4
	xor eax, eax
	ret
ENDP mem_free_ans

; ( a u -- a ior ) MM-090114
PROC mem_realloc_ans
	push eax
	drop
	push eax
	call realloc
	add esp, 8
	jmp mem_alloc_ans.0
ENDP mem_realloc_ans

; For now I will use the libc routines.
PROC mem_alloc
	push eax	
	call malloc
	add esp, 4
.0:
	mov ebx, eax
	sub ebx, ebx
	sbb ebx, 0
	mov [__ior], ebx
	;u
	;upsh 0
	;cmp ebx, 0
	;jnz .1
;	inc eax
;.1:	upop [__ior]
	ret
ENDP mem_alloc

; ( a-addr -- )
PROC mem_free
	push eax
	call free
	add esp, 4
	xor eax, eax
	upop [__ior]
	ret
ENDP mem_free

; ( a-addr u -- a-addr2 )
PROC mem_realloc
	push eax
	drop
	push eax
	call realloc
	add esp, 8
	jmp mem_alloc.0
ENDP mem_realloc

; ( s n <name> -- )
PROC _loadlib
	call _zt
	; load the library:
	push 1 or 0x100	; RTLD_LAZY | RTLD_GLOBAL
	push eax	; library name
	call dlopen
	add esp, 8
	ret
ENDP _loadlib
PROC _unloadlib
	test eax, eax 
	jz .done
	push eax	; library handle
	call dlclose
	add esp, 4
.done:
	drop
	ret
ENDP _unloadlib

; ( s n lib -- handle )
PROC _osfunc
	upop ebx	; EBX is handle
	lodsd		; drop count, EAX is function name
	push esi
	push eax	; symbol
	push ebx	; libhandle
	call dlsym
	add esp, 8
	pop esi
	ret
ENDP _osfunc

_makeexe:
	; chmod = oscall 15
	mov ecx, 448
	mov ebx, eax
	mov eax, 15
	linux
	drop
	ret

;---------------------------------------------------------------------

PROC getpid
	upsh [ourpid]
	ret
ENDP getpid

macro OSDICT {
	DICT 'syscall', os_syscall
	DICT 'getpid', getpid
}

; General code goes here: ---------------------------------------------
include "csp4th-core.asm"

; Our BSS: ---------------------------------------------
