; main source                                               MM-070226
;
; MM-070313 : In table fromdigits, line 1, row E : 80h replaced with -3
;             to make '.' an invalid char in a single number.
; MM-070321 : Fixed failure in ssemi. It failed in the first word of an
;             empty directory, because current @ @ is tero. Replace with
;             last @ .
; MM-070714 : The private/public mode is not reset any more in header
; MM-070901 : unhide renamed to -hide
; MM-070902 : ' zt alias (zt)
; MM-070906 : zt renamed to (zt)
; MM-070907 : '+' and '-' are now marked as invalid chars in table 
;             fromdigits. single now removes a leading '+' or '-' char
;             before converting a string to a number.
;             1, 2, 3, renamed to 1b, 2b, 3b,
; MM-070923 : pc@ and pc! added
; MM-070930 : pc@ and pc! commented out, code moved to os IO
; MM-071004 : new defer xliteral, initially noop
; MM-071014 : _align changed from double- to cell alignment
; MM-071207 : swap added to interpret
; MM-071230 : >cb added
; MM-071231 : >stdcb added, cb: and stdcb: removed , cmove> added
; MM-080101 : _move and move renamed to _cmove and cmove
;             ANS move added
; MM-080205 : single changed to make more than one char after a tick an
;             invalid character input
; MM-080322 : xliteral commented out, not needed, delete later
; MM-080324 : Bugfix in eval and interpret. See comment at eval.
;             is_eval added.
; MM-080920 : parse/ renamed to parse\ , (save) renamed to saved
; MM-090103 : ':' is no longer a macro / immediate
; MM-090123 : allocate, resize and free replaced by ANS conform versions
; MM-090125 : sys-close , sys-open , sys-write , sys-read added
;             close , open/r , open/rw , read , and write commented out
; MM-090127 : ANS read-file added, sys-read deleted
; MM-090131 : sys-close -> close-file , sys-write -> write-file
;             openrw deleted
; MM-090204 : sys-creat added
; MM-090207 : file-size added, fsize removed
;             file-position and reposition-file added
; MM-090304 : place and placez rewritten
; MM-090305 : +place rewritten , +placez added
; MM-090306 : c+place and c+placez added
; MM-090409 : (u.r) _uprintr added
; MM-090806 : slurped added
; MM-090808 : fnbuf and fnzt added
; MM-090808 : open-file moved from fileio.f to the core
; MM-090808 : create-file moved from fileio.f to the core
; MM-090809 : included and include rewritten, errno -37 changed to -38
;             _ztc renamed to _zcount , slurp removed
;             query  made visible and  interpreter added, csp4th.f updated
; MM-090810 : query rewritten
; MM-090811 : _hello rewritten
; MM-090812 : interp rewritten and renamed to interpret
; MM-090813 : sp0 added, holds the current and the initial s0-value
;             s0 changed to 'sp0 @'
;             do_cb changed to set and reset sp0 so that >cb and >stdcb
;             now save and reset sp0 when no error is thrown by the call
;             back routine. If an error is thrown, sp0 must be reset by
;             the error handler. Its (?error) in csp4th.f .
; ----------------------------------------------------------------------
; must be a power of 2 (between 8k and 2mb appear reasonable)
BLZ_WORKMEM_SIZE equ 1024*1024
DICTSIZE equ 1024 * 1K
CODESIZE equ 1024 * 1K
STRSIZE equ 4 * 1K
STACKSIZE equ 2 * 1K
; DSTRSIZE equ 4 * 1K
PADSIZE equ 1K
TIBSIZE equ 1K
NUM_EXIT equ 20
NUM_START equ 20
;;NUM_VOCS equ 10   MM-060523
NUM_VOCS equ 20

SIZE_FIELD equ 8	; offset from dict ptr
XT_FIELD equ 4
NAME_FIELD equ 9
CLASS_FIELD equ -4

; 'Reva' = 'Reva'
align 4 
_start:
	mov [_rp0], esp
	; Do one-time startup:
	call os_start
	; load dictionary ...
	mov esi, _s0
	upsh app_file_name
	call _zcount
_load:	; loads the compressed dictionary data and unpacks it correctly:
	call openr	; handle
	dup ; h h 
;;	call io_size 	; h size	; MM-090809
	call file_size			; 
	drop2				; 
	; h ptr ptr size h
	mov ebx, [esi]	; h -> EBX
	upsh _blz_filebuf
	swap	; h ptr size
	upsh ebx
;;	call io_read ; h rsize	; MM-090809
	call read_file		;
	drop			;
	swap
        call close_file
	drop
	upsh _blz_filebuf
	swap
;	call _slurp
;	jc .err_drop2
	; [ESI] -> ptr (need to free it, don't forget!)
	; EAX -> size
	; ( a n )
	mov ebx, [esi]

	; read the header and verify it's ok
	lea edi, [ebx+eax-4]
	cmp dword [edi], 'Reva'
	jne .bye

	; read the total size:
	mov ecx, [edi-4]
	neg ecx
	; get the start of the data we are interested in:
	lea edi, [edi+ecx+4]
	cmp dword [edi], 'Reva'
	jne .bye

	; we have a valid dictionary now: read it in, piece by piece:
	mov ebp, edi	; edi is used by '_cmove'
	; ( a n )
	; passes our due-diligence.  now read it in:
	; first, copy over our save_header:
	upsh ebp
	upsh save_header
	upsh HEADERSIZE*4
	call _cmove
	; ( a n )
	; bump ebp to next area
	add ebp, HEADERSIZE*4
	mov [sh_ptr2], ebp	; original data

	; we have to allocate a chunk to hold our decompressed data
	; first, how big will it be?
	mov ecx, [sh_ssz]
	add ecx, [sh_bsz]
	add ecx, [sh_hsz]
	add ecx, [sh_dsz]
	mov [sh_size], ecx	; that's how big
;	upsh ecx
;	call mem_alloc
	; the staging area; decompress to there:
	; ( a n p1 )
	mov [sh_ptr1], _blz_buf ; eax
	upsh [sh_ptr1]
	upsh [sh_ptr2]
	upsh [sh_size]
	upsh [sh_ptr1]
	call blz_depack
	drop2
	; ( a n p1 )
	mov ebp, eax 	; [sh_ptr1]
	
	upsh ebp
	upsh static_start
	upsh static_size
	call _cmove

	add ebp, static_size
	upsh ebp
	upsh bss_start
	upsh bss_size
	call _cmove

	add ebp, bss_size
	upsh ebp
	upsh _h0
	upsh [sh_hsz]
	call _cmove

	add ebp, [sh_hsz]
	upsh ebp
	upsh _d0
	upsh [sh_dsz]
	call _cmove
	; ( a n p1 )

	; free the temp ptr:
	drop
	; call mem_free
	jmp .bye ; free the pointer!

	; close the file
.err_drop2:
	drop
.err:	drop
	jmp cold

.bye:	; ( a n )
	drop2
;	ret
;	call mem_free

	; Do every-time startup:
PROC cold
;;				; all this is done in _start !!!! MM-090811
;;	mov esi, _s0		; reset the data stack
;;	xor eax, eax		; 
;;	mov [_rp0], esp		; init r0
	mov esp, [_rp0]		; reset the returnstack   MM-090811

; iterate over 'start handlers' and call each one, in order:
	mov ecx, [@start]
	jecxz .1
	xor ebx, ebx
	push eax
.0:	
	push esi
	push ecx
	push ebx
	call [__start + ebx * 4 ]
	pop ebx
	inc ebx
	pop ecx
	pop esi
	loop .0
	pop eax
.1:
	call appstart
ENDP cold
	; if appstart returns control to cold, terminate with exit-code -1
	mov eax, -1
PROC bye
	push eax
	call cleanup
	dup
	pop eax
	jmp os_bye
ENDP bye


PROC app_file  ; appfile ( -- a u )  MM-070510
	upsh app_file_name
	jmp _zcount
ENDP app_file

; Code for words' implementation:

PROC setprel		; MM-060430   prelude ( xt -- )   xt must be an aligned address
	upop ebx
	test ebx, ebx
	jz .def		; set default class
        inc ebx
        mov [prelude], ebx
        and ebx, 1
        jnz .ret
        mov [prelude], fclass
        upsh -23
        jmp throw
.def:	mov [prelude], fclass
.ret:	ret
ENDP	setprel

PROC fclass_notail
	mov dword [do_tail], 0
	jmp fclass.1
	
ENDP fclass_notail

PROC fclass
	mov dword [do_tail], 1
.1:	
	mov ebx, dword [is_compiling]
	or ebx, ebx
	jnz compile
	; fall through
ENDP fclass
PROC mclass
	mov dword [do_tail], 0
	upop ebx
	jmp ebx	; execute the word
ENDP mclass
PROC iclass
	cmp dword [is_compiling], 0
	je mclass
	; inline the code:
	; EDX is dictionary entry.  -8 is size
	movzx ecx, byte [edx+SIZE_FIELD]
	upop edx
	cmp byte [edx+ecx-1], $c3
	jne store_here.1
	dec ecx
.done:
	jmp store_here.1
ENDP iclass
PROC store_here	; ( addr n -- ) 
	upop ecx ; n
	upop edx ; source addr
align 4
.1:	mov edi, [h]
	add dword [h], ecx
;;	jmp _cmove.a		;; MM-060604
	jmp _cmove.c             ;; changed to test for n = 0
ENDP store_here
PROC compile         
	mov edi, [h]
	sub eax, edi
	sub eax, 5
	mov [edi], byte 0xe8
	inc edi
	stosd
	mov [h], edi
	drop
	ret
ENDP compile

; cmove ( a.src a.dst u -- )
PROC _cmove	        ; 
	upop ecx ; N
.d:	upop edi ; dest
	upop edx ; source
.c:	jecxz .b		;; new label .c by MM-060604
	align 4
.a:	mov bl, byte [edx]      ; htp123 on irc.freenode.net#fasm
	nop
	mov byte [edi], bl	; suggested a fix for these two lines.
	inc edi 	        ; It is now implemented. Thanks!
	inc edx 	        ;
	loop .a 	        ;
.b:
	ret
ENDP _cmove

PROC _cmove_up	        ; MM-071231
	upop ecx ; N
.d:	add eax, ecx
	upop edi ; dest
        add eax, ecx
	upop edx ; source
.c:	jecxz .b
.a:     dec edx
        dec edi
        dec ecx
	align 4
	mov bl, byte [edx]
	nop
	mov byte [edi], bl
        jecxz .b
	jmp .a
.b:	ret
ENDP _cmove_up

PROC _move	        ; MM-080101
	upop ecx ; N
	cmp [ESI], EAX  ; cmp src dst
        jge _cmove.d
        jmp _cmove_up.d
ENDP _move

; ( a n c -- a+off n-off )
PROC rfindchar
	upop ebx	; character
	mov ecx, eax
	mov edi, [esi] ; ptr
	add edi, ecx
	dec edi	; edi-> last character
.next:	cmp byte [edi], bl	; matches?
	je .match
	dec edi
	loop .next
.match: ; edi -> matching character
	cmp byte [edi], bl
	jne findchar.bad
	sub eax, ecx
	inc eax
	mov [esi], edi
	ret
ENDP rfindchar
; ( a n c -- a+off n-off )
PROC findchar
	upop ebx	; character
	mov ecx, eax
	mov edi, [esi] ; ptr
.next:	cmp byte [edi], bl	; matches?
	je .match
	inc edi
	loop .next
.match: ; edi -> matching character
	cmp byte [edi], bl
	jne .bad
	mov eax, ecx
	mov [esi], edi
	ret
.bad:	xor eax, eax
	mov [esi], eax
	ret
ENDP findchar


; p0 p1 p2 p3 ... pN xt N
PROC _call
	push ebp
	mov ebp, esp
	sub esp, 4	; esi

	upop ecx		; nparams
	upop edx		; xt to call
	jecxz .1		; no parameters
.0:	push eax
	drop
	loop .0
.1:	
	upsh ecx	; ECX is zero because of the loop...
	mov [ebp-4], esi
	call edx
	mov esi, [ebp-4]

	mov esp, ebp
	pop ebp
noop:
	ret
ENDP _call

PROC header
	call parsews	        ;
ENDP header

PROC _header
	; save old information so we can back out of a failed compile:
	mov ebx, [h]
	mov [lasth], ebx
	mov ebx, [d]
	mov [lastd], ebx
	mov ebx, [current]  	; ebx = last = current @  MM-060429
	mov ebx, [ebx]		; ebx = last @ = current @ @
	mov [lastl], ebx

	call _align

	mov edi,[d]	        ; LFA
	mov ecx,[current]  	; ecx = current @  MM-060429
	mov edx,[ecx]	        ; edx = current @ @ = dict addr ( = LFA ) of the last
				;                     word in the current wordlist
	add edi, 3
	and edi, -4

	mov ebp, [prelude]	; assign prelude address to the prelude field
	mov [edi], ebp

        mov ebp, [private]	; MM-070430 apply private flags to the prelude field
        or  [edi], ebp

	add edi, 4
	mov [edi],edx	        ; write the dict addr of the last word to the dict addr ( = LFA )
				; of the new word  ; MM-060429
;;	mov [ecx],edi	        ; make last point to the dict addr ( = LFA ) of the new word
        mov [last],edi		; MM-060816
	add edi, 4
	mov ecx,[h]	        ;
	mov [edi],ecx         ; CFA= here
	add edi, 4
	mov [edi], dword 0	; size 
	inc edi
	mov [edi],eax	        ; Length
	inc edi
	upsh edi
	swap
	call _cmove
	mov [d],edi	        ; d= d+9+length
        mov [prelude], fclass 	; MM-060429
;; MM-070714 do not reset the private/public mode
;;	mov dword [private], 0  ; reset private flag MM-070519
	ret
ENDP _header

PROC unhide		; unhide header ( last @ current @ ! )  MM-060817
        mov ebp, [last]		; last @
        test ebp, ebp		  ; nothing to unhide if a word is headerless ( last = 0 )
        jz .ret			  ;
	mov ebx, [current]	;
        mov [ebx], ebp  	; 
.ret:	ret
ENDP unhide

; literal ( x -- ) ANS CORE macro/immediate
PROC literal        ; Compile in a literal
	upop dword [litin.val]
	inline litin, litin2$
ENDP literal

PROC semi 	        ; Compile in an exit to the current word
        call unhide
	call ssemi
	; fall into lbracket
ENDP semi

PROC lbracket	        ; Switch back to the interpreter
	mov dword [is_compiling], 0
	ret	; return to caller of caller
ENDP lbracket
	
PROC ssemi	        ; Exit a word (; will call this!)

        mov ebp, [last]		; ebp = dict addr of the last word  MM-060817
        test ebp, ebp
        jz .nh1

;	mov ebx, [current]  	; MM-060429
;	mov ebx, [ebx]		; ebx->dict entry  Wrong, this is zero in an empty
                                ; directory ! MM-070321

	mov ebx, ebp		; ebx = dict addr of the last word MM-070321
				; this is not zero in an empty directory !

	mov ecx, [ebx+4]	; ecx->CFA
	sub ecx, dword [h]	; size of code
	neg ecx			; ebx->dict, ecx= bytes of code
	lea edx, [ebx+SIZE_FIELD]
	cmp ecx, 256
	jb .ok
	mov ecx,255
.ok:
	mov [edx], cl
.nh1:
	mov ebx,[h]	        ;
	mov ecx, 1
	xchg [do_tail], ecx
	jecxz .notail
	cmp byte [ebx-5],0e8h    ; Was the last thing compiled a CALL?
	jne .notail
.tail:	inc byte [ebx-5]	; --> E9 == jmp 
	ret
.notail:
	; not a call, emplace a 'ret'
	mov byte [ebx], 0c3h	; ret
	inc [h]
        test ebp, ebp		; MM-060817
        jz .nh2			; do not increment code size field of headerless words
	inc byte [edx]
.nh2:	ret
ENDP ssemi

PROC parsews
	dup
	mov edi,[tin]	        ; Pointer into TIB
	mov ecx,[tp]	        ;
	sub ecx,edi	        ;
	inc ecx 	        ;
align 4
.0:	jecxz .1
	mov al, [edi]
	dec ecx
	inc edi
	cmp al, 20h
	ja .1
	cmp al, 09h
	jae .0
.1:
	dec edi 	        ;
	inc ecx 	        ;
	dup		        ;
	mov [esi],edi	        ; a
align 4
.2:	jecxz .3
	mov al, [edi]
	inc edi
	dec ecx
	cmp al, 20h
	ja .2
	cmp al, 09h
	jb .3
.3:

	mov eax,edi	        ;
	dec eax 	        ;
	sub eax,[esi]	        ; n
	mov [tin],edi	        ;
	ret
ENDP parsews

PROC _align
	mov ebx, [h]
.next:
;	test ebx, 7	; MM-071014
	test ebx, 3	; alignment changed from double to cell
	jz .done
	mov byte [ebx], 90h
	inc ebx
	jmp .next

.done:  mov [h], ebx
	ret
ENDP _align
 
PROC _twodup
	mov ebx, [esi]
	lea esi, [esi-8]
	;sub esi, 8	; space for two more
	mov [esi], ebx
	mov [esi+4], eax
	ret
ENDP _twodup

; PROC _pcget ; pc@ ( port-addr -- byte )  MM-070923 070930
;	mov dx, ax
;       xor eax, eax
;       in al, dx
;       ret
; ENDP _pcget

; PROC _pcset ; pc! ( byte port-addr -- )  MM-070923 070930
;	upop edx
;       out dx, al
;	drop
;       ret
;ENDP _pcset

;     place ( str len buf -- ) ANS  MM-090304
PROC _place
	mov ebx, [esi]
	mov [eax], bl
.1: 	inc eax
	xchg eax, [esi]
	jmp _cmove
ENDP _place

;      +place ( str len buf -- ) ANS  MM-090305
PROC  _pplace 
	movzx edx, byte [eax]	; get current count of buf
	mov ebx, [esi]		; add len to count of buff
	add byte [eax], bl 	;
	add eax, edx 		; dest-addr in buf
	jmp _place.1
ENDP _pplace

;	c+place ( c buf -- ) MM-090306
PROC _cpplace
	movzx edx, byte [eax]
        inc edx
        mov byte [eax], dl
        add edx, eax
        upop eax
        mov byte [edx], al
        drop
        ret
ENDP _cpplace

;     placez ( str len buf -- )  MM-090304
PROC _placez
        call _place
        mov byte [edi], 0
        ret
ENDP _placez

;     +placez ( str len buf -- )  MM-090305
PROC _pplacez
        call _pplace
        mov byte [edi], 0
        ret
ENDP _pplacez

;	c+placez ( c buf -- ) MM-090306
PROC _cpplacez
        call _cpplace
        inc edx
        mov byte [edx], 0
        ret
ENDP _cpplacez

PROC _uprintr ; MM-090409
	upop ebp
	and ebp, 255		; clamp width
	mov edi, _npad	        ; edi = buffer (in stack space)
	mov bl, ' '
	mov ecx, [base]
        jmp _printr.a
ENDP _uprintr

PROC _printr
	upop ebp
	and ebp, 255		; clamp width
	mov edi, _npad	        ; edi = buffer (in stack space)
	mov bl, ' '
	mov ecx, [base]
;	cmp ecx, 10     ; MM-090409
;	jne .a
	or eax,eax	        ; Negative?
	jns .a		        ;
	neg eax 	        ;
	mov bl, '-'

.a:	xor edx,edx	        ;
	div ecx		        ;
	add dl,'0'	        ;
	cmp dl,'9'	        ;
	jbe .b		        ;
	add dl,7+32	        ;
.b:	dec edi 	        ;
	mov [edi],dl	        ;
	or eax,eax	        ;
	jnz .a		        ;

	cmp bl, '-'
	jne .c
	dec edi
	mov [edi], bl
.c:
	mov eax,edi	        ; Print
	dup
	mov eax, _npad
	sub eax, edi
	; fixup width
	mov ecx, ebp
	sub ebp, eax
	jle .e
	mov ebx, [padchar]
.d:	dec edi
	mov [edi], bl
	dec ebp
	jnz .d
	mov [esi], edi
	mov eax, ecx
.e:	ret
ENDP _printr

PROC comma 	        ; comma (,) saves a value to "here"
	mov ecx, 4
.0:
	mov edi, [h]
	mov [edi], eax		; stosw without add edi,4
	add [h], ecx		; bump HERE by correct amount
	drop
	ret
ENDP comma

PROC comma3	        ; comma2 (2,) saves 2 bytes to "here"
	mov ecx, 3
	jmp comma.0
ENDP comma3
PROC comma2	        ; comma2 (2,) saves 2 bytes to "here"
	mov ecx, 2
	jmp comma.0
ENDP comma2
PROC comma1	        ; comma1 (1,) saves 1 byte to "here"
	mov ecx, 1
	jmp comma.0
ENDP comma1

; fnzt ( a1 u1 -- a1|a2 ) MM-090808
;      Given a counted string a1 u1 return the address of the coresponding
;      zero-terminated string.
PROC _fnzt
        mov ecx, eax	; u1
        add eax, [esi]
        movzx eax, byte [eax]
        test eax, eax
        jz .ok		; return a1 if string is zero-terminted
	drop
	mov edx, eax	; a1
	mov edi, __fnbuf ; a2
        call _cmove.c
	mov byte [edi], 0	; edi points just behind the string
	mov eax, __fnbuf	
	ret
.ok:	drop
	ret
ENDP _fnzt


; slurped ( a1 u1 -- a2 u2 ff | tf )   MM-090806
PROC _slurped
	call _fnzt
ENDP _slurped
PROC __slurped 		; ( a1 -- a2 u2 ff | tf ) 
	upsh 0		; open r/o
	call sys_open	; ior < 0 = err# , ior >= 0 = fid
        test eax, eax
        jge .fine
        ret
.fine:	mov [slurpy], eax ; eax is fid; save it for later use
	; get file size
	call file_size ; d ior
	drop
	drop
	mov [slurpySize], eax
	call mem_alloc_ans ; a ior
	test eax, eax
        jnz .memerr	; a ior
	; a ior
        drop
	dup ; a a
	upsh dword [slurpySize]
	upsh dword [slurpy]
	; a a u fid
	call read_file	; a u2 ior
        test eax, eax
	jnz .rderr	; a u2 ior
        mov eax, [slurpy]
	call close_file
	ret
.rderr: lea esi, [esi+4] ; nip ; a ior
        swap
        call mem_free_ans ; ior ior
        swap
.memerr: ; a ior
        swap
	mov eax, [slurpy]
	call close_file
        drop
        ret
ENDP _slurped


; open-file ( a u fam -- fid ior )  ; MM-090808
PROC open_file
	upop ebx
	call _fnzt
	upsh ebx
	call sys_open
.1:	dup
	test eax, eax
	jle .ok
	xor eax, eax
.ok:	ret
ENDP open_file

; create-file ( a u fam -- fid ior )  ; MM-090808
PROC create_file
	upop ebx
	call _fnzt
	upsh ebx
	call sys_creat
	jmp open_file.1
ENDP create_file


; This eval from Reva was buggy because it called interpret and stayed in the
; interpreter loop until the next throw occured. A quick bugfix was to
; introduce a variable is_eval to make interpret call query only once.
; A better solution would be to factor out the code used for eval and
; interpret.

;;PROC evalXX ; MM-090810	        ; This takes an address & count to eval
;;;        upsh 69	; only for testing   MM-080324
;;;        call emit	;
;;	push [source]     ; Save "source"
;;	push [tin]        ; Save ">in"
;;	push [tp]         ; Save "tp"
;;	add eax,[esi]	        ;
;;	upop [source]	        ; New "source"
;;	upop [tin]	        ; New ">in"
;;	mov [is_eval], 1  ; MM-080324   make interpret exit at the end
;;	call interpret.eval  ; end of the evaluated string
;;;	call interpret
;;	pop [tp]	  ;
;;	pop [tin]         ;
;;	pop [source]      ;
;;	ret
;;ENDP evalXX

PROC eval ; MM-090810	; This takes an address & count to eval
;        upsh 69	; only for testing   MM-080324
;        call emit	;
	push [source]     ; Save "source"
	push [tin]        ; Save ">in"
	push [tp]         ; Save "tp"
	add eax,[esi]	        ;
	upop [tp]		; new end of text
        mov [source], eax	; new source = start-addr of text
	upop [tin]	        ; New ">in"
	call interpret		;
	pop [tp]	  ;
	pop [tin]         ;
	pop [source]      ;
	ret
ENDP eval

; include ( <name> -- )		; MM-090809
PROC _include			;
	call parsews		;
ENDP _include			; MM-090811
; (included) ( a u -- )
PROC _included
	call _slurped		; ( a u -- a2 u2 ff | tf )   MM-090808
        test eax, eax
	jnz .fail
	drop
	; ptr size
	push dword [esi]	; save the memory ptr
        dup			; MM-060817   support for catch and throw
        mov eax, eval		;
        call catch		; throw-code is now on TOS ( in eax )
	dup			; save throw-code
	pop eax			; get memory ptr
	call mem_free		; free memory
	jmp .2
.fail:	drop
	upsh -38		; signal file open error
.2:	jmp throw		;
ENDP _included

; ( buf count char -- )
PROC _fill
	upop ebx	; char
	upop ecx	; count
	upop edx	; buffer
	jecxz .done
.next:	mov [edx], bl
	inc edx
	loop .next
.done:
	ret
ENDP _fill
; ( str len -- str )
PROC _zt
	upop edx
	add edx, eax
	mov byte [edx], 0
	ret
ENDP _zt
PROC _zcount
	dup
	cmp eax, 0
	jz .q
align 4
.a:     cmp byte [eax],0
        jz .q
        cmp byte [eax + 1],0
        lea eax, byte [eax + 2]
        jnz .a
        dec eax
.q:     sub eax,[esi]
	ret
ENDP _zcount

PROC qm_prelude
; ----------------------------------------------------------- MM-060429
;  The prelude handler
; ---------------------------------------------------------------------
;  if the class field holds an address with the lowest bit set, then
;  it's a prelude address.
;
        and edi, 1		; test if it is a prelude address
        test edi, edi		;
        jz .nopr		; jmp if it's not a prelude
        mov dword [is_prelude], edi ; signal that a prelude is executed   MM-060629
	mov edi, [eax+CLASS_FIELD]
	and edi, 0xfffffffc     ; clear bits 1 and 0
        call edi		; call prelude word
        mov edi, fclass		; set the reva default word class
        jmp .nocls		; continue
.nopr:  mov dword [is_prelude], 0   ; signal that no prelude is executed  MM-070428
	mov edi, [eax+CLASS_FIELD]  ; get word class address
	and edi, 0xfffffffc     ; clear bits 0 and 1  MM-070430
.nocls: ret
; -----------------------------------------------------------
ENDP qm_prelude

; interpret ( -- ) 		; MM-090812
PROC interpret
.word:	call parsews	        ; bl word ( -- a u )
	jz .nogo		; 
.token:	call findinternal 	; (find) ( a1 u1 -- a2 | a1 u1 0 )
	test eax, eax
	jz .trynum		; ( a1 u1 0 ) word not found, may be a number
.found:	mov edx, eax
	mov edi, [eax+CLASS_FIELD]  	; execute the words prelude if any
	call qm_prelude			;
	mov eax, [eax+XT_FIELD]		; get the words xt
	call edi			; execute the word
	jmp .word	     		; and loop back
.trynum:			; ( a1 u1 0 )
	drop			; ( a1 u1 )
	call single		; ( n true | a1 u1 false )
	upop ecx		; ecx = true/false
	test ecx, ecx
	jz .tryother		; ( a1 u1 )
	mov ecx, 1		; ( n ) it's a one cell number
	jmp .lit
.tryother:			; ( a1 u1 )
	call is_word		; ( a1 u1 -- 0 | a2 1 | x 2 | x x 3 | n >= 4 )
; ------------------------------------------------------------------------------
; is_word  is called, if a string was not a known word or single cell number.
;          It's a defered word. It's default is to display the string a1 u1
; with a trailing questionmark and return zero on the TOS.
; You can write your own is_word version, to add extra number conversion or
; other capabilities. It's stack effects have to be
; 
; is_word ( a1 u1 -- 0 | a2 1 | n 2 | n n 3 | n >= 4 )
;
;  with the TOS being one of:
;
;    0 - error, unknown word
;    1 - word found at dictionary address a2
;    2 - one cell value
;    3 - double cell value
;    4 or greater - ignore
;
; and it should call the default is_word routine, with a1 u1 on the stack, if
; a1 u1 is not a word or valid number.
; ------------------------------------------------------------------------------
	upop ecx		; ( -- )
	jecxz .fail		; u2 = 0 : a1 u1 is not a known word or number
	dec ecx
	jnz .lit		; is_word returned ( x 2 | x x 3 | n >= 4 )
	jmp .found		; is_word returned ( a2 1 )
.lit:
	cmp [is_compiling], 1
	jne .word
	cmp ecx, 1
	je .lit1
	cmp ecx, 2
	jne .word
        swap		; MM-071207
	call literal
.lit1:	call literal
	jmp .word
.nogo:  drop2			; 2drop ( a 0 -- )
        ret			;

.fail:	mov ecx, [is_compiling] ; ( -- )
	jecxz .notcompile
	mov [is_compiling], 0
	; blow away last word so we don't try to use it:
	mov ebx, [lasth]
	mov [h], ebx
	mov ebx, [lastd]
	mov [d], ebx
	mov ebx, [lastl]
	mov edx, [current]  ; MM-060429
	mov [edx], ebx
;	mov [current], ebx
.notcompile:
	upsh -13	; MM-090811
	jmp throw	; 
;;	ret		;
ENDP interpret


; ===================================================================
; old interp was removed here ; MM-090812
; ========================================================

;;PROC queryXX ; MM-090810
;;;	upsh 42		; MM-090810	query reads slurped text in one step,
;;;	call emit	;		not line by line
;;	mov dword ecx,[source]  ;	input is from keyboard if source = 0
;;	jecxz .kbd
;;	upsh [tin]
;;	or eax, eax
;;	jz .eof
;;	mov [tin],eax	        ;
;;	sub ecx,eax	        ; Remaining length
;;	jbe .eof	        ;
;;	add eax, ecx
;;	inc ecx
;;	upop [tp]	        ;
;;	clc
;;	ret		        ;
;;.eof:	pop ebx
;;.eof2:  drop		        ;
;;	clc
;;	ret
;;align 4
;;.kbd:	call prompt
;;	mov dword [tp],tib      ; Reset TP, TIN
;;	mov dword [tin],tib     ;
;;.c:	
;;	call key	        ; Get a keypress
;;.redir:
;;	cmp al, 10	        ;
;;	je .eof2		        ;
;;	cmp al, 13	        ;
;;	je .d2		        ;
;;	cmp al, 9		; convert keyed-in TABs into spaces:
;;	je .tab
;;.d:
;;	xchg edi,[tp]	        ; Store the char in the TIB
;;	stosb		        ;
;;	xchg [tp],edi	        ;
;;.d2:
;;	drop		        ;
;;	cmp [tp], tibtop
;;	jb .c		        ; And Loop back around
;;	jmp .eof2
;;.tab:	mov al, ' '
;;	jmp .d
;;ENDP queryXX

; query ( -- ) MM-090810
; Waits for terminal input until the <Enter>-Key is pressed. tin (>in) then
; point to the start of the terminal input buffer tib and tp point just behind
; the last char, that was red into the terminal input buffer.
PROC query
;	upsh 42		; for testing only 
;	call emit	;
; align 4
;;	call prompt	; MM-090814
	mov dword [tp],tib      ; Make TP and TIN=(>in) point to the start of
	mov dword [tin],tib     ; the terminal input buffer (tib)
.c:	call key	        ; ( -- c )
	cmp al, 10	        ; if TOS = LF ? return
	je .eof2	        ; 
	cmp al, 13	        ; if TOS = CR ignore it
	je .d2		        ;
	cmp al, 9		; convert TAB to BL
	je .tab			;
.d:	xchg edi,[tp]	        ; Append char on TOS to the TIB
	stosb		        ;
	xchg [tp],edi	        ;
.d2:	drop		        ; ( c -- )
	cmp [tp], tibtop	; Loop back if TIB isn't full
	jb .c		        ; 
.eof2:	drop		        ; ( c -- )
	ret
.tab:	mov al, ' '
	jmp .d
ENDP query


; (find) ( a1 u1 -- a2 | a1 u1 0 ) Returns the dictionary address a2 if the word
;                                  a1 u1 was found.
PROC __find
	push ebx
        mov ebx, [scontext]      ; MM-060427
	upop ecx	        ;
	push esi
	mov esi,eax	        ;
	mov dh,  byte [eax]     ; get first char to do quick compare:
	mov dl, cl		; and the length; do both compares at once!
align 4 
.a:	mov ebx,[ebx]	        ;
	test ebx,ebx	        ;
	jz .end 	        ; end of wordlist
	lea edi, [ebx+NAME_FIELD]	; point edi at the string
	cmp dx, [edi]		
	jne .a
	inc edi

.len:   push esi	        ; same length, so do the compare
	push ecx	        ;
	repe cmpsb	        ;
	pop ecx 	        ;
	pop esi 	        ;
	jne .a		        ;

.ret3:  mov eax,ebx		; exact match: return XT
.ret:	pop esi
.ret2:  pop ebx 	        ;
	ret
.end:	pop esi
	upsh ecx	        ; no matches
	upsh 0
	jmp .ret2
ENDP __find

; find ( a1 u1 -- xt | a1 u1 0 )
PROC _find
	call findinternal
	test eax, eax
	jz .end
	mov eax, [eax+XT_FIELD]	; read xt from the header at dict-addr 
.end:	ret
ENDP _find

umsg: db  ' ? '   ;; MM-060818

align 4
word_not_found:	 ; ( a u -- 0 )
; -------------------------------------------------------------------
	call type		; Display the name of the word
	upsh umsg
        upsh 3
	call type
	upsh 0
;;	mov eax, -13		; MM-060817
;;	jmp throw		;
	ret

align 4
; ----------------------------------------------------------------------
; ( c -- n ) -- convert character to digit
; ----------------------------------------------------------------------
; This table is used for converting an input character to a digit.  Some special 
; flags are also here: -3 means invalid character (in a number).  80h means NOP 
; - ignore the character, and 80h+xxx means switch to base xxx
fromdigits:
;    0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F

;db -3,  -3,  -3, 8ah, 90h, 82h, 88h,  -3,  -3,  -3,  -3, 80h, 80h, 80h, 80h,  -3  ;2 MM-070313
;   32   33   34   35   36   37   38   39   40   41   42   43   44   45   46   47  ; char code
;         !    "    #    $    %    &    '    (    )    *    +    ,    -    .    /  ; char
;db -3,  -3,  -3, 8ah, 90h, 82h, 88h,  -3,  -3,  -3,  -3, 80h,  -3, 80h,  -3,  -3  ;2 no . or , now
db  -3,  -3,  -3, 8ah, 90h, 82h, 88h,  -3,  -3,  -3,  -3,  -3,  -3,  -3,  -3,  -3  ;2 no [.,+-] now MM-070907

db 00h, 01h, 02h, 03h, 04h, 05h, 06h, 07h, 08h, 09h,  -3,  -3,  -3,  -3,  -3,  -3  ;3
db  -3, 0ah, 0bh, 0ch, 0dh, 0eh, 0fh, 10h, 11h, 12h, 13h, 14h, 15h, 16h, 17h, 18h  ;4
db 19h, 1ah, 1bh, 1ch, 1dh, 1eh, 1fh, 20h, 21h, 22h, 23h,  -3,  -3,  -3,  -3,  -3  ;5
db  -3, 0ah, 0bh, 0ch, 0dh, 0eh, 0fh, 10h, 11h, 12h, 13h, 14h, 15h, 16h, 17h, 18h  ;6
db 19h, 1ah, 1bh, 1ch, 1dh, 1eh, 1fh, 20h, 21h, 22h, 23h,  -3,  -3,  -3,  -3,  -3  ;7
; ----------------------------------------------------------------------
PROC fromdigit

;	cmp eax, 7fh
;	ja .bad
;	cmp eax, 20h
;	jb .bad

	sub eax, 20h
	js .bad
	cmp eax, 5fh
	ja .bad
	mov al, byte [fromdigits + eax]
	cmp al, 080h
	jae .ok
	cmp al, byte [base]
	jae .bad
.ok:
	ret
.bad:	mov al, -3
	ret
ENDP fromdigit
align 4
digits db '0123456789ABCDEF'
PROC todigit		; ( n -- c )  ---- convert digit to correct ASCII 
	cmp al, 16
	jae .weird
	mov al, byte [digits+eax]
	ret
.weird: mov ebx, [base]
	xor edx, edx
	div ebx
	add dl,'0'	        ;
	cmp dl,'9'	        ;
	jbe .b		        ;
	add dl,7+32	        ;
.b:	mov al, dl
	ret
ENDP todigit

PROC parse_with_escape
	mov ebx, '\' 
.top:
	mov edi,[tin]	        ; Pointer into TIB
	mov ecx,[tp]	        ;
	lea ecx, [-1*edi+1]
	mov bh, al		; bl = \  bh = parsechar
	mov ebp, parse_buf 	; ebp = current output location
	xchg esi, edi		; edi == old ESI, esi=src
;;align 4                              ;; skip makes that " " failes  MM-060604
;;	; skip leading delimiter:      ;; skip it not needed here
;;.0:	lodsb		; al == char
;;	cmp al, bh
;;	loope .0
;;	; if ecx is zero, we failed
;;	jz .endofstring

	lodsb		; al == char   ;; get char  MM-060604
align 4
	; skip until trailing character
	; al is already something other than the terminator
.2:	cmp al, bl
	je .escaped
	; not escaped check for end of run
	cmp al, bh
	je .endofstring
	; neither end of string nor escaped:
.onechar:
	mov byte [ebp], al
	inc ebp
	lodsb
	loop .2

	; we ended the loop one way or the other
.endofstring:
	xchg edi, esi	; restore the 'stack' ptr
	mov eax, parse_buf
	dup
	sub eax, ebp
	neg eax
	mov [tin], edi
	ret

.escaped:
	lodsb
	dec ecx
	jmp .onechar
ENDP parse_with_escape

PROC parse	        ;
	mov edi,[tin]	        ; Pointer into TIB
	mov ecx,[tp]	        ;
	sub ecx, edi
	inc ecx
	inc ecx
;	lea ecx, [ecx+-1*edi+2]
	mov ah, [edi]
.1: 	
	dec edi 	        ;
	dup		        ;
	mov [esi],edi	        ; a
align 4
.2:
	mov ah, [edi]
	inc edi
	cmp al, ah
	loopne .2

.3: 	mov eax,edi	        ;
	dec eax 	        ;
	sub eax,[esi]	        ; n
	mov [tin],edi	        ;
	ret
ENDP parse


; same as >cb but for stdcall functions:
; >stdcb ( xt numparams stacksize -- xt.cb )   MM-071231
PROC _stdcbn
	call callback_common
	shl eax, 2
	mov [do_cb_adjust_esp+2], al
	jmp _cbn.1
ENDP _stdcbn
; ----------------------------------------------------------------------
; >cb ( xt numparams stacksize -- xt.cb )   MM-071230
PROC _cbn
	call callback_common
	mov [do_cb_adjust_esp+2], byte 0
.1:
	drop
	;
	mov [do_cb_xt+1], eax
;	drop		; MM-071230
;	call header	;
;	call unhide	;
	mov eax, [h]	; xt.cb of the callback handler
	;
	mov edx, do_cb
	mov ecx, do_cb$
	jmp store_here.1

callback_common:
	shl eax, 2	; num words --> bytes
	mov ebx, [h]
	add ebx, eax
	mov [h], ebx
	drop
	; patch up the code;
	sub ebx, 4
	mov [do_cb_esi+1], ebx
	; 
	mov [do_cb_numparams], eax
	ret
ENDP _cbn

; MM-071231
;
;; same as cb: but for stdcall functions:
;PROC _stdcb
;	call callback_common
;	shl eax, 2
;	mov [do_cb_adjust_esp+2], al
;	jmp _cb.1
;ENDP _stdcb
;; ----------------------------------------------------------------------
;; cb: ( xt numparams stacksize <name> -- )
;PROC _cb
;	call callback_common
;	mov [do_cb_adjust_esp+2], byte 0
;.1:
;	drop
;	;
;	mov [do_cb_xt+1], eax
;	drop
;
;	call header
;	call unhide  	; MM-060816
;	;
;	mov edx, do_cb
;	mov ecx, do_cb$
;	jmp store_here.1
;
;callback_common:
;	shl eax, 2	; num words --> bytes
;	mov ebx, [h]
;	add ebx, eax
;	mov [h], ebx
;	drop
;	; patch up the code;
;	sub ebx, 4
;	mov [do_cb_esi+1], ebx
;	; 
;	mov [do_cb_numparams], eax
;	ret
;ENDP _cb

; default appstart:
; When an error occures, while the core loads a forth source code file given
; on the commend line, program control is returned from interpret to _hello, 
; to appstart and the core exits with an exit-code of -1.
;
hmsg:	db  'Caught: '
;
_hello: ; ( -- ) MM-090811
	call _argc
	cmp eax, 1
	je .1		; no file name given, interpret terminal input
	drop		; include file
	call _argv
	call _zcount
	upop ebx
	add eax, ebx
	inc eax
	call _zcount
	upsh _included
	call catch
        test eax, eax
	jnz .2
	drop	; ?
	ret
.1:	drop		; begin
	call query	;  query
	upsh interpret	;  ['] interpret
	call catch	;
        test eax, eax	; until
	jz .1
.2:	upsh hmsg	; " ? "
	upsh 8		;
	call type	; type
	upsh 0		; 0
	call _printr	; (.r)
	call type	; type
	upsh 10		; cr
	call emit
	ret

PROC _save	; ( a n -- )
	call cleanup
        call _fnzt		; ( a )
	dup			; ( a a )
	; create the new file	; ( a a )
	upsh os_rw
	call sys_creat		; ( a ior )
	test eax, eax
	jl .err0
	; ( a ior=fid=h )
	swap
	call _makeexe
	; EAX is file handle - save it
	dup	; ( h h )
	mov [sh_sig], 'Reva'
	mov [sh_sig2], 'Reva'
	; ok, so read in our exe and write it out:
	upsh app_file_name
	call __slurped		; ( h h a u ior | h h ior )
	test eax, eax		;
	jnz .err2		; ( h h ior )
	drop			; ( h h a u )
	; adjust size if there is already a dictionary appended:
	mov ebx, [esi]
	mov ecx, [ebx+eax-4]
	cmp ecx, [sh_sig] ; 'Reva'
	jne .nosig
	mov ecx, [ebx+eax-8]
	sub eax, ecx
.nosig:
	; save our ptr:
	mov ebx, [esi]
	mov [slurpy], ebx
	; write out the exe
	rot
;;	call io_write		; MM-090809
	call write_file		;
	drop			;
	dup
	; ( fh fh )
	mov [sh_ssz], static_size
	mov [sh_bsz], bss_size
	mov ecx, [h]
	sub ecx, _h0
	mov [sh_hsz], ecx

	mov ecx, [d]
	sub ecx, _d0
	mov [sh_dsz], ecx

	; calculate the total size of our data:
	upsh [sh_dsz]
	add eax, [sh_hsz]
	add eax, [sh_bsz]
	add eax, [sh_ssz]
	dup	; stack has ( size size )
	mov [sh_size], eax	; save our size for later use
	; what is the max we need to have:
	call blz_maxsize
	; allocate a buffer that big:
	call mem_alloc
	upop [sh_ptr2]	; save our dest ptr for compression
	call mem_alloc
	upop [sh_ptr1]	; save the src ptr for compression

	; copy all our data to the sh_ptr1 staging area:
	mov  ebx, [sh_ptr1]
	push ebx

	upsh static_start
	upsh ebx
	upsh dword static_size
	call _cmove
	pop ebx
	add ebx, dword static_size
	push ebx

	upsh bss_start
	upsh ebx
	upsh dword bss_size
	call _cmove
	pop ebx
	add ebx, dword bss_size
	push ebx

	upsh _h0
	upsh ebx
	upsh dword [sh_hsz]
	call _cmove
	pop ebx
	add ebx, [sh_hsz]
	push ebx
	
	upsh _d0
	upsh ebx
	upsh dword [sh_dsz]
	call _cmove
	pop ebx
	add ebx, [sh_dsz]
	push ebx

	pop ebx

	; all the data are in sh_ptr,sh_size  now compress
	upsh [sh_ptr1]
	upsh [sh_size]
	upsh [sh_ptr2]
	call blz_pack
	mov [sh_size], eax
	drop2

	mov [sh_total], dword 0
	upsh save_header
	upsh dword HEADERSIZE*4
	call saveit

	upsh [sh_ptr2]
	upsh [sh_size]
	call saveit

	; write out the full size of data written so-far:
	upsh sh_total
	upsh 8
	call saveit
	drop
	call close_file
	drop
.err:	ret
.err2:	; ( h h ior ) close the errant handle
	swap
	call close_file	; ( h ior ior2 )
.err1:  drop
.err0:	drop2
	ret
ENDP _save
align 4
saveit: ; fh fh ptr size
	test eax, eax
	jz .d2
	add [sh_total], eax
	rot
;;	call io_write	; MM-090809
	call write_file	;
	drop		;
	dup
	ret
.d2:	drop2
	ret

align 4
;copy_with_escape:	; ECX = strlen  ESI = origin EDI = dest
;	push ebx
;	push ecx
;	mov ebx, '\'
;align 4
;.1:
;	mov bh, [esi]
;	inc esi
;	cmp bl, bh
;	je .escaped
;.3:
;	mov [edi], bh
;	inc edi
;	loop .1
;	pop ecx
;	pop ebx
;	ret
;.escaped:
;	mov bh, [esi]
;;;	inc esi
;	dec ecx
;	dec dword [esp]
;	jmp .3
; ----------------------------------------------------------------------
; ( a n -- n true | a n false ) -- sets CF on error
PROC single	        ;
	test eax, eax
	jz .fail1
	; check last char for '.'
	lea ebx, [ebx+eax-1]
	cmp byte [ebx], '.'
	je .fail1 ; double...
	; check first for '
	mov ebx, [esi]
	cmp byte[ebx], 39
	je .base255
	push eax
	push esi
	push [base]
	; count -> ecx
	upop ecx	; n
	upop edi	; a
;--------------------------------
        ; remove leading sign  MM-070907
	cmp byte[edi], 43
        je .sign
	cmp byte[edi], 45
        jne .nosign
.sign:  inc edi
        dec ecx
.nosign:
;--------------------------------
	mov esi, edi
	jecxz .fail
	inc ecx
	mov ebx, [base]
	xor edx, edx	; accumulate in EDX
	xor eax, eax
.next:	dec ecx
	jz .ok
	lodsb
	call fromdigit
	cmp al, -3
	je single.fail
	cmp al, 80h
	je .next
	ja .special
	; multiply the accumulator by base, add in new digit:
	push eax
	mov eax, edx
	mul ebx
	mov edx, eax
	pop eax
	add edx, eax
	jmp .next
.special:
;	cmp al, -1
;	je .special2
	and al, 7fh	; strip top bit
;.special2:
	movsx ebx, al
	mov [base], ebx
	jmp .next
	
.ok:	; edx is value to push
	pop [base]
	pop esi
	pop eax
	mov eax, edx
	mov edx, [esi]
	mov dl, byte [edx]
	cmp dl, '-'
	jne .ok2
	neg eax
.ok2:
	add esi, 4
	upsh -1
	ret
.fail:
	pop [base]
	pop esi
	pop eax
.fail1:
	upsh 0
	ret
.base255:
; ---------------------- MM-080205
        cmp eax, 2       ; only accept one char after the tick char
        jne .fail1
; ----------------------
	drop
	inc eax
	movzx eax, byte [eax]
	upsh -1
	ret
ENDP single

PROC colon 	        ; Ok, this is the entry to the compiler
	call header
	call rbracket
	ret 
ENDP colon

PROC rbracket	        ; This is the actual compiler loop
	mov dword [is_compiling], 1
	ret
ENDP rbracket

; class modifiers:
PROC _forth_nt
	mov [prelude], fclass_notail
	ret
ENDP _forth_nt
PROC _forth
	mov [prelude], fclass
	ret
ENDP _forth
PROC _macro
	mov [prelude], mclass
	ret
ENDP _macro
PROC _inline
	mov [prelude], iclass
	ret
ENDP _inline
; Look for a2 in a1; a3 is returned if flag is true
; Case-sensitive; Uses BRUTEFORCE algorithm
; ( a1 n1 a2 n2 -- a3 n3 1 | 0 )	
PROC search
	upop edx	; n2
	upop edi	; a2
	upop ecx	; n2
	; EAX:ECX ==> A1
	; EDI:EDX ==> A2
	; be unamused by zero-length or NULL strings:
	push eax
	push ecx
	jecxz .failed
	or eax, eax
	jz .failed
	or edx, edx
	jz .failed
	or edi, edi
	jz .failed

	; main loop: scan for possible match: first character matches:
	; EAX:ECX --> string to search in; we bump through it until we fall off
	; the end:
.next:
	mov bh, byte [edi]	; first character of target - this won't change
.findstart:
	mov bl, byte [eax]	; get first character of source string
	cmp bl, bh
	je .maybe		; maybe we match; check it out
.nomatch:	; nah, bump to next char
	inc eax
	loop .findstart
	; if we made it here, we are big failures:
.failed:
	xor eax, eax
	pop ecx		; drop n2
	pop ecx		; drop a2
	ret

.maybe: ; EAX:ECX might be a match to EDI:EDX
	cmp ecx, edx
	jb .failed	; string-to-match is longer than matchee
	mov ebp, edx	; save matcher length
	dec ebp
.maybe2:
	mov bh, [edi+ebp]
	cmp bh, [eax+ebp]
	jne .nomatch2
	dec ebp
	jns .maybe2
	; fell off loop: we matched!
	dup
	pop eax		; N1
	sub eax, [esi]	; A1
	pop ebx
	add eax, ebx
	; upsh edx
	dup
.success:
	mov eax, 1
	ret
.nomatch2:
	inc eax
	jmp .next
ENDP search

; compare a1 and a2; if identical upto min(n1,n2) then (n1==n2)?0:(n1<n2)?-1:1;
; ( a1 n1 a2 n2 -- result )
PROC compare
	upop edx	; n2
	upop edi	; a2
	upop ecx	; n1

; Internal routine:
; EAX:ECX --> string1
; EDI:EDX --> string2
; leaves EAX=result
; trashes EDI, ECX,, EDX
strcmp:
	push esi
	mov  esi, eax	; a1
	mov  eax, edx	; n2
	sub  edx, ecx	; n2-n1
	neg  edx
	cmp  ecx, eax
	jl .ok1
	mov ecx, eax	; compare for shorter of two lengths
.ok1:	jecxz .done
	repe cmpsb 	; if Z then strings compare equal
.done1:
	jz .equal
	mov al, [esi-1]	; do lexicographic compare
	sub al, [edi-1]
	movsx eax, al
	jmp .done
.equal: mov eax, edx
.done: 	pop  esi
	ret
ENDP compare

; Implementation of FNV-1a hash:  http://www.isthe.com/chongo/tech/comp/fnv/
; ( str len -- hash )

PROC  fnvhash
	upop ecx	; ECX is len, EAX is stringptr
	mov ebx, eax
.0:
	mov eax, 2166136261	; offset-basis
	mov ebp, 16777619	; FNV prime (32bits)

.1:
	xor al, [ebx]
	mul ebp
	inc ebx
	loop .1
	ret
ENDP fnvhash

PROC onstartup
	mov ebx, [@start]
	cmp ebx, NUM_START
	jge .done
	mov [__start + ebx*4], eax
	inc ebx
	mov [@start], ebx
.done:	drop
	ret
ENDP onstartup
PROC onexit
	mov ebx, [@exit]
	cmp ebx, NUM_EXIT
	jge .done
	mov [__exit + ebx*4], eax
	inc ebx
	mov [@exit], ebx
.done:	drop
	ret
ENDP onexit
; iterate over 'exit handlers' and call each one, in reverse order:
_exit_handler:
	mov ecx, [@exit]
	jecxz .1
.0:	
	push esi
	push ecx
	push eax
	call [__exit + ecx * 4 - 4]
	pop eax
	pop ecx
	pop esi
	loop .0
.1:
	ret


PROC cb_catch
	; save data stack
	push esi
	; save value of current handler
	push [handler]
	; save value of ESP to 'handler'
	mov [handler], esp
	; execute the XT we got:
;;	mov ebx, eax
;;	lodsd
	call ebx
	; if we are here, no 'throw' happened so clean the stack
	pop [handler]
	pop ebx	; get rid of saved ESI
	upsh 0	; make sure caller knows there was no failure
	ret
ENDP cb_catch



PROC catch
	; save data stack
	push esi
	; save value of current handler
	push [handler]
	; save value of ESP to 'handler'
	mov [handler], esp
	; execute the XT we got:
	mov ebx, eax
	lodsd
	call ebx
	; if we are here, no 'throw' happened so clean the stack
	pop [handler]
	pop ebx	; get rid of saved ESI
	upsh 0	; make sure caller knows there was no failure
	ret
ENDP catch
PROC throw
	test eax, eax
	jz .nothrow
	; throw code in eax - return control to caller of 'catch'
	mov ebx, [handler]
	test ebx, ebx
	jz .nothrow	; blech!  NULL makes a poor handler...
	mov esp, ebx	; set ESP back to the context of the catch
	pop [handler]	; restore old handler
	pop esi		; restore previous data stack, but with throwcode on top
	ret		; return to caller
.nothrow:
	drop
	ret
ENDP throw

; s0 ( -- a )
PROC s0
	upsh [sp0]
	ret
ENDP s0

PROC _os
	upsh OS
	ret
ENDP _os
; ------ COMPRESS (LZSS) ROUTINES
include 'brieflz.asm'
; ------ COMPRESS (LZSS) ROUTINES
; STUBS:
align 4
litin:
	dup
	db 0b8h	; mov eax, imm32
litin$ = $-litin
.val:   dd 0
litin2$ = $-litin
; Stub for a callback called from an external "C" routine.
; These values are patched up, and the result is copied into 'here'
; to be executed at run-time.
do_cb:
	pusha
do_cb_esi: ; patch ESI to our own private spot:
	mov esi, dword 0
; ----- set sp0 for the background task		; MM-090813	
	mov [sp0], esi				;
; -------------------------------------		;
;	mov ecx, 0
	db $b9
do_cb_numparams: ; move parameters from ESP stack to our stack:
	dd 0
	jecxz do_cb_xt

	lea ebx, [esp+36]
do_cb_copy_params: ; loop over parameters and 'push' them
	upsh dword [ebx]
	add ebx, 4
	loop do_cb_copy_params

do_cb_xt: ; move the target XT to EBX
	mov ebx, 0
; ----------------------------------- MM-090814 add a pointer to the first
;	upsh [sp0]                  ; stack element   ( wid data oid )
;	add eax, -8
; -----------------------------------
	; and call it!
	call dword ebx
	mov [cb_eax], eax
; ----- restore sp0 for the foreground task	; MM-090813
	mov eax, [sp0+4]			;
	mov [sp0], eax				;
; ----------------------------------------	;
	popa
	mov eax, [cb_eax]
do_cb_adjust_esp: ; 83 C4 00
	ret 0
	cb_eax: dd 0
do_cb$ =  $ - do_cb

VAR _sp0, sp0			; MM-090813
VAR rp0, _rp0
VAR _tin, tin
VAR _tp, tp
VAR _tib, tib
VAR _src, source
VAR _padchar, padchar
VAR _prelude, prelude
VAR prelude_qm, [is_prelude]
VAR _private, private
VAR appname, app_file_name
VAR _dict, d
VAR __here, h
VAR _base, base
VAR _pad, __pad
VAR _hinst, [hinstance]
VAR stdout, [StdOut]
VAR stdin, [StdIn]
VAR _argv, [argv]
VAR _argc, [argc]
VAR compiling, [is_compiling]
VAR _vocs, NUM_VOCS		; MM-060429
;; VAR _last, [current]  		; MM-060429
VAR _last, last  		; MM-060816
VAR _scontext, scontext		; MM-060428
VAR _vcontext, vcontext		; MM-060428
VAR _ccontext, ccontext		; MM-060428
VAR _current, current		; MM-060429
VAR _esm, esm			; MM-060429
VAR _osm, osm			; MM-070430
VAR _ecm, ecm			; MM-060506
;;VAR s0, _s0			; MM-090813  is now a word
VAR d0, _d0
VAR h0, _h0
VAR __str0, _str0
VAR _env, [environ]
VAR ior, __ior
VAR _fnbuf, __fnbuf		; MM-090808

PROC var
	dup
	pop eax
	ret
ENDP var

PROC _context			; MM-060429
        upsh vcontext
        mov ebx, [esm]
        test ebx, ebx
        jz .voc			; return the vocabulary search context
        mov eax, ccontext	; return the class search context
.voc:   ret
ENDP _context 

HEADERSIZE = 5

align 4
; -- END STUBS --
is_compiling dd 0
is_eval      dd 0	; MM-080324
hinstance dd 0
; dictonly dd 0
StdIn dd 0
StdOut dd 0
source		dd 0
tin		dd 0	        ; >IN
tp		dd tib	        ; TP (pointer to input buffer)

; ----------------------------------------------------------------------
; This gets persisted:
; ----------------------------------------------------------------------
;_st0 		dd __st0 ; dynamic strings

align 4
static_start:
align 4
	mylink=0
	OSDICT	; os-specific words, defined in core?in.asm
	DICT 'cold', cold	; reinitialize system
	DICT 'prompt', prompt
	DICT '(prelude)', _prelude
	DICT 'prelude?', prelude_qm		; MM-060824 MM-061004
	DICT '(private)', _private		; MM-070430
	DICT 's0', s0
	DICT 'd0', d0
	DICT 'h0', h0
	DICT '>lz', blz_pack
	DICT 'lz>', blz_depack
	DICT 'lzmax', blz_maxsize
 	DICT 'prelude', setprel
	DICT "'default", fclass
	DICT "'notail", fclass_notail
	DICT "'macro", mclass
	DICT "'inline", iclass
	DICT 'dovar', var
	DICT '(env)', _env
	DICT 'catch', catch
	DICT 'throw', throw
	DICT 'ioerr', ior
	DICT 'str0', __str0
	DICT 'rp0', rp0
	DICT 'onexit', onexit
	DICT 'onstartup', onstartup
	DICT 'cleanup', cleanup
;	DICT 'cb:', _cb		; MM-071231
	DICT '>cb', _cbn	; MM-071230
;	DICT 'stdcb:', _stdcb	; MM-071231
	DICT '>stdcb', _stdcbn	; MM-071231
	DICT '(lib)', _loadlib
	DICT '(-lib)', _unloadlib
	DICT '(call)', _call
	DICT '(func)', _osfunc

	DICT 'fnvhash', fnvhash
	DICT '(bye)', bye
	DICT '>in', _tin
	DICT 'tib', _tib
	DICT 'tp', _tp
	DICT 'search', search
	DICT 'cmp', compare
	DICT 'place', _place
	DICT 'placez', _placez
	DICT '+place', _pplace
	DICT '+placez', _pplacez
        DICT 'c+place', _cpplace
        DICT 'c+placez', _cpplacez
	DICT 'src', _src
	DICT '(argv)', _argv
	DICT 'argc', _argc
	DICT 'cmove',_cmove
	DICT 'cmove>',_cmove_up		; MM-071231
	DICT 'move',_move		; MM-080101
	DICT 'fill', _fill
;	DICT 'zt',_zt			; MM-070906
	DICT '(zt)',_zt
	DICT 'zcount',_zcount
	DICT 'hinst', _hinst
	DICT 'stdout', stdout
	DICT 'stdin', stdin
;	DICT 'open/r', openr		; MM-090125
;	DICT 'sys-open', sys_open	; MM-090125 090808
;	DICT 'sys-creat', sys_creat	; MM-090808
        DICT 'close-file', close_file	; MM-090131
	DICT 'read-file', read_file	; MM-090127
	DICT 'write-file', write_file	; MM-090131
	DICT 'file-size', file_size	;
	DICT 'reposition-file', repos_file  ; MM-090207
	DICT 'file-position', file_pos	; MM-090207
;	DICT 'allocate', mem_alloc	; MM-090123 remove the code later
	DICT 'allocate', mem_alloc_ans	;
;	DICT 'free', mem_free		;
	DICT 'free', mem_free_ans	;
;	DICT 'resize', mem_realloc	;
	DICT 'resize', mem_realloc_ans	;
	DICT 'header', header
	DICT '(header)', _header
        DICT '-hide', unhide
	DICT 'literal', literal, mclass
;;	DICT 'xliteral', xliteral	; MM-071004  MM-080322
;	DICT ';;', ssemi, mclass	; MM-070510
	DICT 'exit', ssemi, mclass	; MM-070510
	DICT '(os)', _os
	DICT 'parsews',parsews
	DICT 'align', _align
	DICT 'here,', store_here
;	DICT 'compile', compile			; MM-070516
;	DICT 'compile,', compile		; MM-070517  MM-070514
	DICT 'compile,', compile, mclass	; MM-070517
	DICT 'query', query			; MM-090809
	DICT 'interpret', interpret		; MM-090812
	DICT 'key', key
	DICT 'appstart',appstart
	DICT 'emit', emit
	DICT 'find', _find
	DICT '(find)', findinternal
	DICT '>single',single
	DICT 'word?', is_word
	DICT 'type', type
	DICT 'digit>', fromdigit
	DICT '>digit', todigit
;	DICT ':', colon, mclass		; MM-090103
	DICT ':', colon
	DICT ';', semi, mclass
	DICT '[', lbracket, mclass
;	DICT ']', rbracket, mclass	; MM-070517
	DICT ']', rbracket		;
	DICT 'compiling?', compiling
	DICT 'dict', _dict
	DICT '(here)', __here
	DICT 'pad', _pad
        DICT '#vocs', _vocs
	DICT 'last', _last
        DICT 's.context', _scontext
        DICT 'v.context', _vcontext
        DICT 'e.context', _ccontext
        DICT '(esm)', _esm
        DICT '(osm)', _osm
        DICT '(ecm)', _ecm
        DICT 'current', _current
        DICT 'context', _context
	DICT '2dup', _twodup
	DICT 'base', _base
	DICT 'sp0', _sp0		; MM-090813
	DICT ',' , comma
;	DICT '3,' , comma3		; MM-070907
	DICT '3b,' , comma3
;	DICT '2,' , comma2		; MM-070907
	DICT '2b,' , comma2
;	DICT '1,' , comma1		; MM-070907
	DICT '1b,' , comma1
	DICT 'c,' , comma1		; MM-070514
	DICT 'include', _include	; 
	DICT 'included', _included	; MM-090808
;	DICT 'eval', eval		; MM-070517
	DICT 'evaluate', eval		;
	DICT 'parse',parse
	DICT 'parse\', parse_with_escape
;	DICT 'forth', _forth, mclass	; MM-060430 fclass is now the default word class
	DICT "notail", _forth_nt, mclass
	DICT 'macro', _macro, mclass
	DICT 'inline', _inline, mclass
;;	DICT 'appname', appname		; MM-070510
	DICT 'appfile', app_file	; 
	DICT 'saved', _save
	DICT 'execute', mclass
	DICT "(.r)", _printr
	DICT "(u.r)", _uprintr		; MM-090409
	DICT "padchar", _padchar
	DICT '/char', findchar
	DICT '\char', rfindchar
;        DICT 'pc@', _pcget		; MM-070923 070930
;        DICT 'pc!', _pcset		; MM-070923 070930
	DICT 'slurped', _slurped	; MM-090806
	DICT 'fnzt', _fnzt		; MM-090808
	DICT 'fnbuf', _fnbuf		;
	DICT 'open-file', open_file	; uses fnbuf
	DICT 'create-file', create_file	; uses fnbuf

forth_link=mylink
DEFER prompt
DEFER appstart, _hello 
DEFER key, os_key
DEFER findinternal, __find
DEFER is_word, word_not_found
;; DEFER xliteral                 MM-080322
DEFER type, os_type
DEFER emit, os_emit
DEFER cleanup, _exit_handler
align 4
NONBSS
flast    dd forth_link
last     dd forth_link
current  dd flast	; pointer to the current compilation context   ; MM-060429
scontext dd flast	; pointer to the search context used in (find) ; MM-060427

;vcontext dd NUM_VOCS dup flast, 0   ; MM-060428
vcontext dd  2 dup flast, NUM_VOCS-1 dup 0   ; MM-060506

ccontext dd  2 dup flast, NUM_VOCS-1 dup 0   ; MM-060506

esm	 dd 0		; MM-060429   
osm      dd 0		; MM-070430   true in object search mode
ecm	 dd 0           ; MM-060506

padchar dd 32
h	dd _h0
d	dd _d0		;
base	dd 10
sp0	dd _s0, _s0	; | current s0 | initial s0 |
prelude dd fclass	; default is no prelude
is_prelude dd 0		; MM-060624  true while a prelude is executed
private dd 0		; MM-070430  %10 if word is class private, i.e.
			;                hidden for objects
                        ;            %00 if word is public, i.e. visible
			;                for objects
@exit dd 0	; number of exit handlers in __exit
@start dd 0	; number of start handlers in __start
handler dd 0
static_size = $-static_start

; ----------------------------------------------------------------------
; END PERSISTED STATICS
; ----------------------------------------------------------------------

; ----------------------------------------------------------------------
align 4
BSS
align 4
__start rd NUM_START	; allow up to twenty handlers
__exit rd NUM_EXIT	; allow up to twenty handlers
bss_size = $-bss_start

save_header:
	; These are sanity-check values:
	sh_sig rd 1		; initial signature
	; These are data-size values:
	sh_ssz rd 1		; static data size
	sh_bsz rd 1		; bss data size
	sh_hsz rd 1		; code size
	sh_dsz rd 1		; dict size
	; uncompressed size =
	;  sh_ssz + sh_bsz + sh_hsz + sh_dsz

	; These are tail-sanity-check values:
	sh_total rd 1		; total actually written out
	sh_sig2 rd 1		; final signature for sanity-check

	; These are for compression and decompression:
	sh_size rd 1
	sh_ptr1 rd 1		; uncompressed data
	sh_ptr2 rd 1		; compressed data

	rb 256
_npad:
;__st0 rb DSTRSIZE	; dynamic strings (4k)
;__st0end:
app_file_name	rb 256
lasth rd 1
lastd rd 1
lastl rd 1
environ rd 1
argv rd 1
argc rd 1
tempX rd 2		; temp vars
slurpy rd 1
slurpySize rd 1
; so we can undo bad compiles:
;__aux rd AUXSIZE

; the data stack:  | underflow area | stack area      |   | overflow area |
;                       16 cells      STACKSIZE cells ^        16 cells
;                                                    _s0

rd 16		; Stack overflow area.
rd STACKSIZE	; Stack (2k normal)
;; _s0  rd 1				; MM-090813  unused cell removed
;; rd 16	; underflow area.	;
_s0 rd 16	; Stack underflow area.	;

__pad rb PADSIZE

__fnbuf rb 257		; Buffer for zero-terminated file names  MM-090808

tib rb TIBSIZE		; Text Input Buffer (1k)
tibtop:
blz_limit rd 1
blz_bkptr rd 1

__ior rd 1
_rp0 rd 1
do_tail rd 1

 align 4 
_h0  rb CODESIZE		; Code 
_str0 rb STRSIZE		; compiled strings
_d0  rb DICTSIZE		; Dictionary 
parse_buf rb 128*1K
_blz_filebuf rb 128*1K		; for 'slurp'ing the file
_blz_buf rb (DICTSIZE + STRSIZE + DICTSIZE )
blz_workmem rb BLZ_WORKMEM_SIZE
; ---------------------------------------------------------------------------
