
include base.f
include if.f
include loc.f
include extra.f
include string.f
include loop.f
include misc.f
include preproc.f
| include func.f
include os.f       | words  time&date , ms , ms@ , getpid removed
                   | Windows broken   MM-060815
include fileio.f
include phrase.f   | new MM-060819
include pushpop.f  | new MM-060820
include needs.f

include patches.f  | new MM-071026

loc:

 : .ver ( -- ) ." csp4th for " osname type ;

 : .(c) ( -- ) ." .   Copyright (C) 2008 Manfred Mahlow.    " ;

 : .war ( -- ) ." This software comes " cr
               ." with absolutely no warranty, see the LICENSE file. "
               ." Type 'bye <enter>' to exit." ;

| loc:

 : 0dirs() ( -- ) | MM-080324
   | Init dir(1) with "appdir/user"
     appdir pad place 'ps pad c+place pad c@ >r " user" pad +place
     pad count 80 min dir(1) placez
   | Init dir(2) with "appdir/share"
     r> pad c! " share" pad +place  pad count 80 min dir(2) placez ;

 : (error) ( -- ) | error handling    MM-090814
           src off                    | reset input |
           sp0 cell+ @ sp0 !          | restore sp0 for main task  MM-090813
           0 prelude  decimal         | no prelude  and  base = decimal
           ." Caught: " . cr          | issue message
           [compile] [ ;              | interpreter mode

 : ?rc ( -- ) | MM-080409 MM-090125
  | Try to include ~/.appnamerc
    " HOME" getenv " ." 'ps join  appname 0 join " rc" 0 join
    2dup r/o open-file nip if 2drop else included then ;


 : argv ( u1 -- c-addr u2 )  | MM-070525 
   dup argc 1- >if drop pad 0 exit then  | return pad 0 if arg# > argc-1
   0 max (argv) swap ?dup 0if zcount exit then 0 do zcount + 1+ loop zcount ;

 1 variable, argc#

 : argv> argc# @ 1+ argv argc# ++ ;

 : e 2drop argv> evaluate ;
 : n 2drop argv> needed ;
 : t 2drop argv> taken ;
 : v 2drop verbose on ;
 : X 2drop argc argc# ! ;

 : unknown  drop type ."  ? unknown option  " -1 throw ;

 choices: args?
	' e 'e choice  | -e
	' n 'n choice  | -n
        ' t 't choice  | -t  
        ' v 'v choice  | -v
	' X '- choice  | --  end of parameter list
	' unknown default

 : (hi) over count '- =if c@ args? else drop included then ;  

 : argdo 1 argc# ! begin   | MM-070226 : 1 argc# !
    argc# @ argv (hi)
	argc# dup ++ @
	argc swap - 0 max 0until ;


 : hello ( -- )
   argc 1- 0if .ver .(c) .war cr ?rc exit then ?rc argdo ;

 :noname ( -- )
    0dirs() ['] hello catch ?dup if (error) -1 (bye) then
    begin query ['] interpret catch ?dup if (error) else prompt then again
 ; is appstart  | MM-090814

 :noname ( -- ) ."  ok" cr ; is prompt  | MM-070307

  reveal (error)
  reveal argv

loc; 

| Generate the Reva executable:
  appdir pad place 
  (os) [IF] " /csp4th" [ELSE] " \csp4th.exe" [THEN]
  pad +placez pad count saved bye

| -----------------------------------------------------------------------------
| MM-070319  (?error) now resets the base to decimal
| MM-070510  ;; -> exit
| MM-070516  p: -> [compile]
|            error handling for options modified
| MM-070525  argv changed to return a string with a size of zero, for an index
|            >= argc.
| MM-070831  renamed to revaOE
| MM-071019  renamed to revaOE-n
| MM-071019  Appname renamed to csp4th
|            This file renamed to csp4th.f
| MM-080205  pathsep -> 'ps
| MM-080207  new: ?defs to read defaults.4th
| MM-080208  ?defs commented out because of bad error handling
| MM-080324  Initial loading of config file added.  0dirs() changed.
| MM-080530  Reva repeat -> begin , Reva while -> 0until
| MM-080916  (needs) -> needed , (take) -> taken
| MM-080920  (save) -> saved
| MM-090101  do loop ... -> DO LOOP ...
| MM-090103  :: -> :noname
| MM-090104  ?rc moved from appstart to hello to be executed after boot message
| MM-090125  in ?rc open/r replaced with open-file
| MM-090305  +place -> +placez
| MM-090307  DO LOOP -> do loop ...
| MM-090809  (include) -> included
| MM-090809  interp replaced by query interpreter
| MM-090811  (?error) changed
| MM-090812  interpreter renamed to interpret
| MM-090814  (error) factored out of (?error), (?error) and ?error removed
| MM-090919  argcend removed, old obsolet code removed

