
; interpreter ( -- ) 	MM-090809
PROC interp
;        upsh 42
;	call emit
	mov [is_eval], 1
	jmp interpret.word
ENDP interp

; ( xt -- exception# | 0 )


; interpreter goes here:
PROC interpret
	mov [is_eval], 0	; MM-080325
.o:	; upsh  81    ; only for testing
        ; call emit   ;
.eval:	call query	        ; ( Get a LINE )

align 4
.word:	call parsews	        ; ( Parse until we find <SPACE> )
	jz .nogo
; ----------------------------------------------------------------------
; Tokenizer: reads one word from input, and converts it to a token
; ( a n -- 0 | xt 1 | n 2 | n n 3 | 4 )
; TOS on return is one of:
;   0 - error, can't parse it
;   1 - XT of a found word
;   2 - one cell value
;   3 - then double-cell value
;   4 (or greater) - ignore
; Calls 'is_word', which permits the user to hook into this process and over-
; ride it if desired.  The 'is_word' is passed the string to parse on the stack.

;align 4
.token:
	call findinternal ;  find the words dictionary/header address
	test eax, eax
	jz .trynum	; failed, look for a number
	; success!
	mov ecx, 1
	jmp .afterok

.trynum:	
	drop
	call single	; try a number
	upop ecx
	test ecx, ecx
	jnz .single
.tryother:
	call is_word
	upop ecx
	jecxz .fail
	jmp .afterok
.single:
	mov ecx, 2
align 4
.afterok:
	dec ecx
	jnz .lit
	mov edx, eax
	mov edi, [eax+CLASS_FIELD]
	call qm_prelude			; execute the words prelude if any
	mov eax, [eax+XT_FIELD]		; get the words xt
	call edi			; execute the word
	jmp .word	        ; ( And Loop back )
.lit:
;;	upsh ecx	; MM-071005        ; removed MM-080322
;;	call xliteral	; ( n 1 | d 2 | >2 -- )
;;	upop ecx	;
	cmp [is_compiling], 1
	jne .word
	cmp ecx, 1
	je .lit1
	cmp ecx, 2
	jne .word
        swap		; MM-071207
	call literal
.lit1:	call literal
	jmp .word
.nogo:  drop2
;	jmp .o			; MM-080324
        cmp [is_eval], 0	;
        je .o			;
        ret			;

.fail:	mov ecx, [is_compiling]
	jecxz .notcompile
	mov [is_compiling], 0
	; blow away last word so we don't try to use it:
	mov ebx, [lasth]
	mov [h], ebx
	mov ebx, [lastd]
	mov [d], ebx
	mov ebx, [lastl]
	mov edx, [current]  ; MM-060429
	mov [edx], ebx
;	mov [current], ebx
.notcompile:
	upsh -13	; MM-090811
	jmp throw	; 
;;	ret		;
ENDP interpret
