| forth
: .2x 16 /mod >digit emit >digit emit ; 

: .x 4 0 do 256 /mod loop drop  4 0 do .2x loop space ;

  : .s  ." Stack: " depth dup '( emit (.) type ') emit space
        0 max 0; 10 min
        dup 0 do dup i - pick . loop drop ;

| : rdepth rp0 @ rp@ - 2 >> ;  MM-081113
  : rdepth rp0 @ rp@ - 2 rshift ;

  : .rs rdepth 1- dup '( emit (.) type ') emit space
        0 max dup 0; 10 min 
	0 do dup i - rpick .x loop drop ;

loc: | New version of word  MM-070831

  variable #ln

  variable c/l

  2variable (s)  pad 0 (s) 2!

  : matched? ( a u -- a u true | false )
    2dup (s) 2@ dup if search nip nip else 2drop 2drop true then
  ;    

  : (.name) ( da -- )
    (osm) @ if | do not show private words in object search mode.
      dup >class @ %10 and if drop exit then
    then
    >name count matched? 0if exit then  dup 2 + c/l +!
    c/l @ 80 > if | CR if the string does not fit into the line
      cr  #ln ++  dup c/l !
    then
    type  c/l @ 78 < if space space then
  ;

  : show-wordlist ( wid -- )
    0; #ln off c/l off
    begin
      @ 0; dup (.name) #ln @ 10 > if
        cr ."   *** Press [Enter] to stop the listing, any other key to continue. ***"
        cr
        ekey #10 = if
          drop exit 
        else #ln off
        then
      then
    again
  ;

  : words ( -- )
    context @ show-wordlist
  ;

  : grep ( "chars" -- )
    parsews (s) 2!  words  pad 0 (s) 2!
  ;

| ---------------------------------------------------------------------------
| implementation of 'dump' :
: ?nl dup 0; 16 mod not 0; drop over cr .x ;
| : dump 0; over .x 0 do | iterate for each line:
|        i ?nl drop dup c@ .2x space 1+ loop drop cr ;
: dump 0; over .x 0 do | iterate for each line:
         i ?nl drop dup c@ .2x space 1+
       loop drop cr ;  | MM-090101

reveal show-wordlist
reveal words
reveal grep
reveal dump
loc;

: see parsews (find) ?dup if dup >xt @ swap >size c@ 0; dump else type ' emit cr then ;

loc:
variable action 
: choices: create 0 , ['] noop , 
  does>  ( n -- )
	dup cell+ @ action !
	dup @ dup 0if drop 2drop exit then | don't do anything if no choices
	>r	| count on return-stack
	cell+
	begin 
		| get next 'choice' and see if it matches:
		cell+ dup @ 2 pick =if
			| it does, so execute and quit:
			rdrop nip cell+ @execute exit
		then
		| bump to next 'choice' and decrement choices left count:
		cell+ r> 1- dup >r 
	0until drop
	| don't forget to clean up if we didn't do anything:
	rdrop action @execute ;
reveal choices:
loc;
: choice ( xt n -- ) last @ >xt @ 5 + ++ , , ;
: default ( xt -- ) last @ >xt @ 9 + ! ;

| new class: 'alias - this word executes the word pointed to:

macro : 'alias ( xt -- )
		| the 'xt' of this word is actually the dict of the aliased word:
		dup >xt @ swap >class @execute ;

macro	: alias: ( newname oldname )
		header -hide last @ dup '' | newd newd oldd
		swap >xt !	| newd
		>class ['] 'alias swap !
	;

| forth

: lc ( c -- c' ) $20 or ;
| : cmpi ( a1 n1 a2 n2 -- result )
| 	2 pick over <>if 2drop 2drop -1 exit then
|	drop swap | a1 a2 n1
|	0 do
|		count | a1 a2' c2
|		rot count | a2' c2 a1' c1
|		lc rot lc <>if 2drop unloop 1 exit then
|	loop
|	2drop 0
|	;

: cmpi ( a1 n1 a2 n2 -- result )
	2 pick over <>if 2drop 2drop -1 exit then
	drop swap | a1 a2 n1
	0 do
		count | a1 a2' c2
		rot count | a2' c2 a1' c1
		lc rot lc <>if 2drop unloop 1 exit then
	loop
	2drop 0
	;  | MM-090101

loc:
2variable envvalue

: envcmp (os) if cmp else cmpi then ;
: nulenv drop 2drop 0 0 rdrop ;
: getenv  ( a n -- a' n' )
	(env) | a n envptr
	begin
		dup c@ 0if nulenv then
		dup >r zcount '= split if 2swap envvalue 2! else drop rdrop nulenv then
		2over envcmp 0if 2drop rdrop envvalue 2@ exit then
		r> 
		zcount + 1+
	again
	;
reveal getenv
loc; 

| these are all called with a stack: a n x
| where 'a' is the buffer to put the char in
|       'n' is the buffer's max size
|       'x' is the number of characters in it
|   and 'c' is the current character (for the default)
loc:
variable (accept)
: bs? dup if 8 emit space 8 emit 1- then true ;
: cr? false ;
: esc? drop 0 false ;
: anykey dup emit | show the key
	| max n c
	 over (accept) @ + c!  | put character in buffer
	 1+ 2dup - ; 
choices: accept?
	' anykey default
	' bs? 8 choice
	' cr? 10 choice
	' cr? 13 choice
	' esc? 27 choice

( a n -- n2 ) | accept
: accept swap (accept) !	| store away the buffer:
	0 begin ekey accept? 0until nip ;
reveal accept
loc; 

2variable findme
: findnext ( a n -- )
        dup 0if ." hide ?  Input missing  " -1 throw then  | MM-070907
	findme 2!
|	context @ @  ( last @ , MM-060504 )
        current @ @  | MM-070524 search the current compilation context !
        dup 0if findme 2@ 0 ?hu then  | MM-070907 
	| is the first word the one?
	dup >name count findme 2@ cmp 0if
		| yes it's the top word!  just set last to the next word
		| @ context @ !  ( last ! )  | MM-070524
                @ current @ !                |
	else
		begin 
			| get next word's name:
		      | dup @ dup 0if 2drop exit then  >name count | MM-070907
			dup @ dup 0if findme 2@ 0 ?hu then  >name count
			| is it the word we want?
			findme 2@ cmp 0if
				| yes it is; unlink that word:
				dup @ @ swap ! exit
			then
			@
		again 
	then
	;
: hide ( <name> -- )
	parsews findnext
	;
hide findme
hide findnext

| Implemenation of 'mark'. Define a word with:
|    mark mywords
| and when you invoke 'mywords', the dictionary is cleaned up
| to the state it had just before you created 'mywords'
: mark ( <name> -- )
	last @
	create , dict @ , here cell+ ,
	does> dup @ last !
		cell+ dup @ dict !
		cell+ @ (here) ! 
	;

| defer help    | MM-080409
| loc:
| : nohelp ." No help system found!" cr ; 
| variable helped
| :noname helped @ 0if helped ++ " needs helper" evaluate help else nohelp then ; is | help
| loc;


| MM-070510  ;; -> exit  ANS
| MM-070517  eval -> evaluate  ANS
| MM-070524  hide changed to hide words from the current compilation context
|            and not from the search context.
| MM-070901  unhide renamed to -hide
| MM-070906  old words removed
| MM-070907  hide changed to throw an error if a word is not found or if
|            input is missing.
| MM-080409  reva help removed
| MM-080530  Reva repeat -> begin , Reva while -> 0until
| MM-090101  do loop ... -> DO LOOP ...
| MM-090103  :: -> :noname
| MM-090307  DO LOOP -> do loop ...
