
  alias: \ |
  : \\ ( -- ) tp @ >in ! ; \ skip rest of text input stream
  alias: (C (
  alias: (R (
  alias: (S (
\ -----------------------------------------------------------------------------
\                  Mixed words and modifications of the core.
\ -----------------------------------------------------------------------------
\
\                      Copyright (c) 2006-2007 Manfred Mahlow


\  : read ( a u fd -- u' ) read 0 max ;  MM-090125

\  : eof ( -- ) src @ newsrc ; | stop processing this file ( from reva util/misc)

  hide mark

\ redefinition with error message if a word is not found.  MM-070306

  hide reveal

: reveal ( <name> -- )
	| see if <name> is valid; return quietly if not:
        parsews (find) ?dup 0if type ."  ?  " -1 throw then
	| move us into parent vocab as last:
	1 rpick | (lastvoc)
	| us voc
	over ! | us 
	1 cells rp@ + ! 
	;

: ?pad ( a1 u1 -- a2 u1 )
       \ If the string a1,u1 is placed on the pad ( a1 = pad+1 ), copy it 
       \ zero-terminated to the rotating string buffer and return its new
       \ address and its count on the stack. Do nothing if the string is
       \ not placed on the pad.
  over pad 1+ = if "" then
;

  : cb ( "name" xt numparams stacksize -- ) >cb constant ;

  : stdcb ( "name" xt numparams stacksize -- ) >stdcb constant ;

  : join ( a1 u1 a2 u2 c -- a3 u3 )
  \ Append a2 u2 to a1 u1 separated by character c. c = 0 = no separator.
    >r 2swap dup 3 pick + 3 + (buf) >r   (R -- c a3-1) (S a1 u1 a2 u2 )
    r@ place 1 rpick dup if r@ c+place else drop then
\   r@ +place r> count 2dup + 0 swap c! rdrop ;   MM-090305
    r@ +placez r> count rdrop ;

  : /1/ ( a1 u1 -- a2 u2 )
  \ Prepend dir(1) to string a1 u1.
    dir(1) count 2swap 'ps join ;

  : /2/ ( a1 u1 -- a2 u2 )
  \ Prepend dir(2) to string a1 u1.
    dir(2) count 2swap 'ps join ;

  : /?/ ( a1 u1 -- a2 u2 )
  \ If the file a1,u1 exists in dir(1) return the path to that file,
  \ otherwise return the path to the file in dir(2).
  \ 2dup /1/ 2dup open/r dup 0 > if close 2swap 2drop exit then \ MM-090125
    2dup /1/ 2dup r/o open-file 0if close-file drop 2swap 2drop exit then
    drop 2drop /2/ ;

  \ Note : /1/, /2/, /?/ :The string a2,u2 is placed zero terminated in the
  \        rotating string buffer.

\   : >r@ ( x -- x ) dup >r ;

  : >r@ ( x -- x ) (R -- x ) r> over >r >r ;  \ MM-080324

\ -----------------------------------------------------------------------------
\ MM-070304  'read' redefined, to return u' = 0 on error
\ MM-070326  zt redefined.
\ MM-070430  ?on removed
\ MM-070518  Added \G (G (C (O (R (S
\ MM-070823  Added ?pad
\ MM-070902  Added @dir()
\ MM-070906  Moved zt to string.f
\ MM-070906  @dir , @dir(1) , @dir(2) factored aout of @dir()
\ MM-071231  cd and stdcb added ,  /1/ /2/ /?/ new
\ MM-080101  @dir removed, @dir(1) , @dir(2) , @dir() renamed and redefined 
\                      to   /1/    ,   /2/   , /?/
\ MM-080104  join rewritten, >r@ new
\ MM-080324  bugfix in >r@ , placez added
\ MM-090125  /?/ changed to use open-file and close-file , read deleted
\ MM-090304  placez moved to the core
\ MM-090305  +place -> +placez in join
\ MM-090812  \\ added


